<?php
require_once("dll.php");
$variables->getSafeVars(array_keys($_POST));

if ($action == "edit" && $catID && $parentID != '') { // check for errors before any editing
    if ($categories->isTheOnlyRoot($catID, $section) && $parentID > 0) $messages->addError(t("Δεν μπορεί να μείνει η κατηγοριοποίηση χωρίς πρώτο επίπεδο (root)"));
    if ($catID == $parentID) $messages->addError(t("Η κατηγορία δεν μπορεί να έχει γονική σχέση με τον εαυτό της"));
    if ($categories->isRoot($catID, $section) && $categories->getRoot($parentID, $section) == $catID) $messages->addError(t("Με  την συγκεκριμένη γονική κατηγορία θα χαθεί η επαφή με το πρώτο επίπεδο κατηγοριοποίησης (root)"));
    if (!$messages->hasErrors) { // proceed
        //get actual parent
        $storedParent = $db->getRecord("select `parent` from $section where id='$catID'")->parent;
        $isParentModified = ($parentID != $storedParent);

        if ($categories->isPreorderTreeTraversal($section) && $isParentModified) { // edit by Modified Preorder Tree Traversal Model
            // first restore to Adjucency List Model
            $q = "ALTER TABLE $section DROP column L, DROP column R";
            $db->query($q, false);
            $db->query("UPDATE `$section` SET parent='$parentID' where id='$catID'"); // update withj one simple query
            // then restore to Modified Preorder Tree Traversal Model
            $mysqlType = "INT(10) NULL DEFAULT NULL";
            $q = "ALTER TABLE `$section` ADD `L` $mysqlType ";
            $db->query($q, false);
            $q = "ALTER TABLE `$section` ADD `R` $mysqlType ";
            $db->query($q, false);
            $categories->rebuildTree($section);
        } else { //edit by Adjucency List Model
            $db->query("UPDATE `$section` SET parent='$parentID' where id='$catID'");
        }
    }else{
        $messages->printSystemMessages();
    }
    $menu->displayTree($section, 'categories_tree');
    exit;
}

/******************************************************************************************************/

$itemID = (int)$_REQUEST['itemID'];
$tableSectionID = $system->getTableSectionID(str_replace("_categories", null, $section));

if($itemID && $section && $action=="delete"){ // its gonna be removed
	$parentSection = $categories->getParentSection($section);
	$parentTableSectionID = $system->getTableSectionID($parentSection);
	
	if($categories->isParent($itemID, $section)){ // parent node detected, delete not permited
		die(t("Για λόγους ασφαλείας δεν μπορείτε να διαγράψετε μια γονική κατηγορία επιλογών!<br>Πρέπει να δείτε που οδηγεί η συγκεκριμένη κατηγορία και να αρχίσετε να διαγράφετε από εκεί"));
	}
	if(!$content->recordExists($itemID, $section) ) die(t("Η κατηγορία δεν βρέθηκε"));
	
	$SLsectionID = $parentTableSectionID;
	$SLfieldID = $system->getFieldID("catID", $SLsectionID);
	$SLoptionID = $itemID;
	$q="select itemID from selectlists where sectionID='$SLsectionID' and fieldID='$SLfieldID' and optionID='$SLoptionID'";
	$itemsIDsArray = $db->getRecords($q);
	$itemsIDs = array();
	if(count($itemsIDsArray)){
		foreach($itemsIDsArray as $element){
			$itemsIDs[] = $element->itemID;
		}
		$itemsIDs = implode(",", $itemsIDs);
	}else{
		$itemsIDs = NULL;
	}
	
	if($itemsIDs){
		$q="select distinct id from `$parentSection` where catID='$itemID' or id IN(".$itemsIDs.")";
		$records = $db->getRecords($q);
	}else{
		$q="select distinct id from `$parentSection` where catID='$itemID'";
		$records = $db->getRecords($q);
	}

	foreach($records as $row){
		$id2delete = $row->id;
		$multiCategories = $categories->getMultiCategories($parentTableSectionID, $id2delete);	
		if(count($multiCategories) < 2){ // ok to delete content cause either one item found to multicategories or its single category
			$content->removeContent($id2delete, $parentSection, "main");
		}
	}
	
	if($categories->isPreorderTreeTraversal($section)){			
		$db->query("LOCK TABLE $section WRITE");
		$db->query("SELECT @myLeft := L, @myRight := R, @myWidth := R - L + 1 FROM $section WHERE id = '$itemID'");
		$db->query("DELETE FROM $section WHERE L BETWEEN @myLeft AND @myRight");
		$db->query("UPDATE $section SET R = R - @myWidth WHERE R > @myRight");
		$db->query("UPDATE $section SET L = L - @myWidth WHERE L > @myRight");
		$db->query("UNLOCK TABLES");
	}else{
		$db->query("delete from `$section` where id='$itemID' ");
	}
	$content_table = "content_".$section;
	$db->query("delete from $content_table where catID='$itemID'");
	$db->query("DELETE FROM content_aliases, aliases USING content_aliases INNER JOIN aliases	
					   WHERE content_aliases.mainID=aliases.id 
					   AND aliases.itemID='$itemID' 
					   AND aliases.sectionID='$tableSectionID' 
					   AND aliases.isCategory=1");	
					   
	// delete any image category for this entry
	$categoryImage = "..".DIRECTORY_SEPARATOR."mediabank".DIRECTORY_SEPARATOR.$categories->getCategoryImage($itemID, $tableSectionID);	
	if(is_file($categoryImage)) unlink($categoryImage);	
	die("ok");
}
