<?php
require_once("dll.php");

$langID = $language->getDefaultLanguage();
$parameters->importParameters();
$isMultilingualSite = $language->isMultilingualSite();
$variables->getSafeVars(array('bankID', 'linkID', 'sectionID'));

?>
<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <link rel="shortcut icon" href="favicon.ico">
    <title>Admin Panel</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link href="css/admin.css" rel="stylesheet" type="text/css">
    <link href="css/sort.css" rel="stylesheet" type="text/css">
    <link type="text/css" href="css/ui/jquery-ui-odyshop.css" rel="stylesheet">
    <link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

    <script type="text/javascript" src="js/jquery.js"></script>
    <script type="text/javascript" src="js/admin.js"></script>
    <script type="text/javascript" src="js/jquery-ui-All.min.js"></script>
    <script type="text/javascript" src="js/jquery.ajaxform.js"></script>
    <script type="text/javascript" src="js/jquery-impromptu.js"></script>
    <script type="text/javascript">
        $(document).ready(function() {
            $("#sort-list-video").sortable({
                handle : '.handle',
                update : function () {
                    var order = $('#sort-list-video').sortable('serialize');
                    $("#sortInfo").load("sort.php?"+order+"&table=videos");
                }
            });
        });

        function setDragStyle(elm, typeOfEvent){
            if(typeOfEvent == "startDrag"){
                hideRecords();
                elm.parentNode.style.border="dashed 3px #7b8168";
                elm.parentNode.style.background="#ededed";
            }else{
                elm.parentNode.style.border="dashed 3px transparent";
                elm.parentNode.style.borderBottom="dashed 3px silver";
            }
        }

        function showFields(id){
            hideRecords();
            $('#button_'+id).hide();
            $('#record_'+id).show('fast');
        }

        function hideRecords(){
            $('.attachment_record').each(function(){
                $(this).hide();
            });
            $('.attachment_button').each(function(){
                $(this).show('fast');
            });
        }

        function saveForm(id){
            $('#submit_'+id).attr('value', t('Αποστολή δεδομένων'));
            $("#form_"+id).ajaxSubmit({
                url: 'ajax_videos.php',
                type: 'post',
                success: showResponse
            });
        }

        function showResponse(responseText, statusText, xhr, $form)  {
            if(statusText != "success"){
                popup(t("Υπήρξε κάποιο πρόβλημα κατά την αποθήκευση των δεδομένων"), "popup-warning");
            }else{
                var data = responseText.split("~~|~~");
                var id= data[0];
                var title = data[1];
                if(parseInt(id) > 0){
                    $('#submit_'+id).attr('value', t('Αποθηκεύθηκε'));
                    if(title) $('#caption_'+id).html(title);
                    setTimeout(function(){
                        $('#submit_'+id).attr('value', t('Αποθήκευση'));
                        hideRecords();
                    }, 2000);
                }else{
                    popup(t("Σφάλμα")+": " + responseText, "popup-warning");
                }
            }
        }

    </script>
    <style type="text/css">
        <!--
        body {
            overflow: auto;
            background: #ededed;
        }
        -->
    </style>
    <?php include("includes/languages.css.php"); ?>
</head>
<body id="inner_page">
<div id="sortInfo"></div>
<div class="section_title"><?php echo t("ΜΕΤΟΝΟΜΑΣΙΑ ή ΤΑΞΙΝΟΜΗΣΗ ΕΠΙΣΥΝΑΠΤΟΜΕΝΩΝ ΒΙΝΤΕΟ"); ?></div>
<?php
$query = "SELECT distinct videos.*, content_videos.title FROM videos, content_videos WHERE videos.linkID='$linkID' and videos.sectionID='$sectionID' and content_videos.mainID=videos.id and content_videos.langID='$langID' order by videos.sort";
$rows=$db->getNumRows($query);
$records=$db->getRecords($query);
if(!count($records)){
    ?>
    <script>
        parent.$('#video_instructions').css('display','none');
    </script>
    <div style="height:50px">&nbsp;</div>
    <?php
    $messages->addMessage(t("Δεν έχετε επισυνάψει ακόμα, κανένα βίντεο στην συγκεκριμένη εγγραφή")."!");
    $messages->printSystemMessages();
}
?>
<div id="attachments_results">
    <div style="text-align:right;">
        <input type="button" class="btn btn-warning" style="margin-top: -30px" value="<?php echo t("Επιστροφή");?>" onclick="parent.$.fancybox.close()">
    </div>
    <div style="font-size: .9em; text-align:right;"><?php echo t("Για νέα ταξινόμηση σύρτε τα εικονίδια στην επιθυμητή θέση");?></div>
    <ul id="sort-list-video" style="list-style-type:none; margin: 20px auto;">
        <?php
        foreach($records as $row){
            $fileID = $row->id;
            $ext = $fileSystem->getExtensionByFileTypeID($fileSystem->getFileTypeID($row->bankID));
            $videoProvider = $row->provider;
            $videoCode = $row->videoCode;
            $videoURL = $content->getVideoURL($videoProvider, $videoCode);
            $videoThumb = $content->getVideoThumb($videoProvider, $videoCode);
            ?>
            <li id="listItem_<?php echo $row->id;?>" style="border-bottom: dashed 3px silver; padding-bottom:5px; margin-top:50px;">
                <div class="video_thumb_wrapper" style="background: url(<?php echo $videoThumb;?>) no-repeat center center;">
                    <iframe width="220" height="150" src="<?php echo $videoURL;?>" style="border:none"></iframe>
                </div>
                <div class="handle" onmousedown="setDragStyle(this, 'startDrag');" onmouseup="setDragStyle(this, 'stopDrag');" style="display:table; margin: -50px auto 0 auto;"> <img src="images/sort_icon.png" alt="move" width="78" height="70" align="absmiddle" style="position:relative; z-index:100; cursor:move"> </div>

                <a id="button_<?php echo $row->id;?>" class="btn btn-info attachment_button" href="javascript:void(0)" style="display:block" onclick="showFields('<?php echo $row->id;?>');"><?php echo t("Εμφάνιση στοιχείων προς επεξεργασία");?></a>
                <form id="form_<?php echo $row->id;?>" class="admin_form form_centered" style="min-width:260px">
                    <div id="record_<?php echo $row->id;?>" class="normal attachment_record" style="float:left;margin:20px 0; display:none;">
                        <?php
                        $Lresult =$db->query("SELECT * FROM languages WHERE active=1 ");
                        $LRecords = $db->getRows($Lresult);

                        foreach($LRecords as $Lrow) {
                            $languageID = $Lrow->id;
                            $title = $db->getRecord("select title from content_videos where mainID='$fileID' and langID='$languageID'")->title;
                            $extension = ($Lrow->extension) ? $Lrow->extension : '_gr';
                            ?>

                            <div class="admin_form_element">
                                <div class="admin_label admin_flag"> <?php echo t("Τίτλος");?> : </div>
                                <div class="flaged_wrapper">
                                    <div class="flag_border"></div>
                                    <input name="title<?php  echo $extension;?>" id="title<?php  echo $extension;?>" type="text" class="listbox flaged flag<?php  echo $extension;?>" placeholder="<?php  if($Lrow->extension && $isMultilingualSite){echo(' '.t('στα').' '.$Lrow->title);}?>" value="<?php echo $title;?>" style="width: 100% !important">
                                </div>
                            </div>
                            <?php
                        }
                        ?>
                        <div class="admin_form_element">
                            <div class="admin_label<?php echo $flag_class; ?>">
                                <?php echo t("Εμφάνιση σε"); ?> : <select name="language_id" class="listbox attachment_languages">
                                    <?php
                                    $selected_language = ($row->language_id == '0') ? " selected" : "";
                                    ?>
                                    <option value="0"<?php echo $selected_language;?>><?php echo t("όλες τις γλώσσες"); ?></option>
                                    <?php
                                    $q = "select * from `languages` where active='1' ";
                                    $languages = $db->getRecords($q);
                                    foreach ($languages as $lang_row) {
                                        $langTitle = ($langID == 1) ? $lang_row->title : $lang_row->title_translated;
                                        $selected_language = ($row->language_id == $lang_row->id) ? " selected" : "";
                                        ?>
                                        <option value="<?php echo $lang_row->id; ?>"<?php echo $selected_language;?>><?php echo $langTitle; ?></option>
                                        <?php
                                    }
                                    ?>
                                </select>
                            </div>
                        </div>
                        <div class="admin_form_element">
                            <input id="submit_<?php echo $row->id;?>" type="button" class="btn btn-success" value="<?php echo t("Αποθήκευση");?>" onclick="saveForm('<?php echo $row->id;?>');">
                            <input name="writedata" type="hidden" id="writedata" value="1">
                            <input name="linkID" type="hidden" id="linkID" value="<?php  echo $linkID;?>">
                            <input name="fileID" type="hidden" id="fileID" value="<?php  echo $row->id;?>">
                            <input name="sectionID" type="hidden" id="sectionID" value="<?php  echo $sectionID;?>"></td>
                        </div>
                    </div>
                </form>
                <div style="clear:both;"></div>
            </li>
            <?php
        }
        ?>
    </ul>
</div>
<div style="height:40px;"></div>
</body>
</html>
