<?php
require_once("dll.php");
$variables->getSafeVars(array_keys($_REQUEST));

function getCropDataID() {
    global $imageID;
    global $db;
    $q = "select c.`sectionID` 
            from `crops_data` as cd, `crops` as c  
            where cd.cropID=c.id 
            and cd.`imageID`='$imageID' "; // check for existing
    $rows = $db->getRecords($q);
    $sectionIDs = array();
    foreach ($rows as $row) $sectionIDs[] = $row->sectionID;
    $sectionIDs = implode(",", $sectionIDs);
    $id = false;
    if ($sectionIDs) {
        $q = "select cd.`id` from `crops_data` as cd, `crops` as c where cd.cropID=c.id and cd.`imageID`='$imageID' and c.sectionID IN ('$sectionIDs')";
        $id = $db->getRecord($q)->id;
    }
    return $id;
}

function getSelectedCropDataID() {
    global $imageID;
    global $db;
    global $cropID;
    $q = "select `id` from `crops_data` where cropID='$cropID' and `imageID`='$imageID' ";
    $id = $db->getRecord($q)->id;
    return $id;
}

if ($mode == 'ajax') {
    if ($action == 'save') {
        // sanitize
        $width = (int)$width;
        $height = (int)$height;
        $x1 = (int)$x1;
        $y1 = (int)$y1;
        $x2 = (int)$x2;
        $y2 = (int)$y2;
        if (!$imageID || !$cropID || !$x2 || !$y2) die("Cannot save, parameters missing!");
        $id = (int)$id;
        if ($id) {
            $q = "REPLACE INTO `crops_data` VALUES ('$id', '$imageID', '$cropID', '$width', '$height', '$x1', '$y1', '$x2', '$y2')";
        } else {
            $q = "INSERT INTO `crops_data` VALUES ('', '$imageID', '$cropID', '$width', '$height', '$x1', '$y1', '$x2', '$y2')";
        }
        // save data
        $db->query($q);
        die("ok");
    }
    if ($action == 'delete') {
        $id = (int)$id;
        if(!$id) die("No id to delete defined!");
        $db->query("delete from `crops_data` where `id`='$id'");
        die("ok");
    }
    die("No ajax action defined!");
}


if (!$sectionID) {
    $messages->addError("No sectionID defined!");
} else {
    $section = $system->getSectionProperty($sectionID, 'name');
    $crops = $content->getContent("crops", " crops.sectionID=$sectionID", "*", array('title'), $langID);
    if (!$crops) {
        $messages->addError("No crops defined for this section!");
    } else {
        $image = $db->getRecord("select * from `images` where id='$imageID'");
        if (!$image) {
            $messages->addError("Image not found!");
        } else {
            $bankID = $image->bankID;
            $ext = $fileSystem->getExtensionByFileTypeID($fileSystem->getFileTypeID($bankID));
            if (!$fileSystem->isImageExtension($ext)) $messages->addError("File has no valid image extension!");
            $image = $bankID . "." . $ext;
            $imageFile = "../mediabank/images/" . $image;
            if (!is_file($imageFile)) $messages->addError("Image not found in media directory!");
        }
    }
}
if (!$messages->hasErrors) {
    $crop_data_id = getSelectedCropDataID();
    $id = getCropDataID();
    $crop_data = false;
    $cropID = ($cropID) ? $cropID : $crop_data_id;
    if ($id) {
        $q = "select * from `crops_data` where `id`='$id'";
        $crops_data = $db->getRecord($q);
        $originalCropID = $crops_data->cropID;
        if (!$cropID) $cropID = $originalCropID;
    }
    if ($cropID) {
        foreach ($crops as $crop) {
            if ($crop->id == $cropID) $crop_data = $crop;
        }
    }
    $crop_data = ($crop_data) ? $crop_data : $crops[0]; // get selected crop or the first one
    $maxWidth = $crop_data->max_width;
    $maxHeight = $crop_data->max_height;
    $cropID = ($cropID) ? $cropID : $crop_data->id;
}
if (!$maxWidth || !$maxHeight) $messages->addError("No valid crop dimensions found!");
?>
<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <link rel="shortcut icon" href="favicon.ico">
    <title>Admin Panel - Order Details</title>
    <link href="css/admin.css" rel="stylesheet" type="text/css">
    <link href="js/imgareaselect/css/imgareaselect-default.css" rel="stylesheet" type="text/css">
    <link rel="stylesheet" media="all" type="text/css" href="css/jquery-impromptu.css">

    <script type="text/javascript" src="js/jquery.js"></script>
    <script type="text/javascript" src="js/admin.js"></script>
    <script type="text/javascript" src="js/jquery-impromptu.js"></script>
    <script type="text/javascript" src="js/imgareaselect/jquery.imgareaselect.js"></script>
    <!--[if IE 8]>
    <script type="text/javascript" src="js/respond.min.js"></script>
    <![endif]-->
    <style type="text/css">
        body {
            overflow: auto;
            background: #ededed;
            margin: 0;
            padding: 0;
        }

        .close_modal {
            position: absolute;
            top: 15px;
            right: 20px;
            background-image: url(images/close_prompt.png);
            background-repeat: no-repeat;
            background-position: 8px center;
            padding-left: 30px;
            border: 2px solid #EDEDED;
        }

        .save_selection {
            clear: both;
            display: none;
            min-width: 80px;
        }

        #save_btn {
            text-align: right;
            margin: 10px;
        }

        #image_for_selection {
            display: table;
            margin: 10px auto;
        }

        #image_for_selection img {
            display: block;
        }

        .is_data {
            border: none;
            float: right;
            color: #9a2a54;
            font-size: 1.2em;
        }

        .is_data td:first-child {
            text-align: right;
            color: #9e9e9e;
            font-weight: bold;
        }

        .is_data td:last-child {
            text-align: left;
        }

        .crops_select_container {
            text-align: center;
            margin: 10px auto;
        }

        @media (min-width: 1900px) {
            .container {
                width: 1900px;
                margin: 0 auto;
            }
        }
    </style>
    <script type="text/javascript">

        var is = {};

        is.min = 200;

        function unescapeQuotes(safe) {
            return safe.replace(/&amp;/g, '&')
                .replace(/&quot;/g, '"')
                .replace(/&#034;/g, "'")
                .replace(/&#039;/g, "'");
        }

        function closeImageArea() {
            parent.$.fancybox.close();
        }

        function gcd(w, h) {
            return (h == 0) ? w : gcd(h, w % h);
        }

        function aspect_ratio(w, h) {
            var factor = gcd(w, h);
            return w / factor + ":" + h / factor
        }

        function saveSelection() {
            var x1 = $('#x1').val();
            var y1 = $('#y1').val();
            var x2 = $('#x2').val();
            var y2 = $('#y2').val();
            var width = $('#w').val();
            var height = $('#h').val();
            jQuery.ajax({
                type: "GET",
                url: "image_area.php",
                data: "mode=ajax&action=save&id=<?php echo $id;?>&imageID=<?php echo $imageID;?>&cropID=<?php echo $cropID;?>&x1=" + x1 + "&y1=" + y1 + "&x2=" + x2 + "&y2=" + y2 + "&width=" + width + "&height=" + height,
                async: false,
                success: function (response) {
                    if (response == 'ok') {
                        closeImageArea();
                    } else {
                        popup(response, "popup-warning");
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    popup(textStatus, "popup-warning");
                }
            });
        }
        <?php
        if($id){
        ?>
        function deleteSelection() {
            var id = '<?php echo $id;?>';
            jQuery.ajax({
                type: "GET",
                url: "image_area.php",
                data: "mode=ajax&action=delete&id=" + id,
                async: false,
                success: function (response) {
                    if (response == 'ok') {
                        $('#crops_select').trigger('change');
                    } else {
                        popup(response, "popup-warning");
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    popup(textStatus, "popup-warning");
                }
            });
        }
        <?php
        }
        ?>

        function updateSelection(selection) {
            selection = selection || '';
            if (typeof selection == 'object') {
                var data = getActualValues(selection.x1, selection.y1, selection.width, selection.height);
                updatePanel(data.x1, data.y1, data.x2, data.y2, data.width, data.height);
            }
        }

        function getActualValues(x1, y1, width, height) {
            var viewportW = $('#image_for_selection').width();
            var viewportH = $('#image_for_selection').height();
            is.percentW = 100 * (width / viewportW);
            is.percentH = 100 * (height / viewportH);
            is.actualSelectionWidth = parseFloat(is.img_width * (is.percentW / 100));
            is.actualSelectionHeight = parseFloat(is.img_height * (is.percentH / 100));
            is.actualSelectionWidth = (is.actualSelectionWidth > is.max_width) ? is.max_width : is.actualSelectionWidth;
            is.actualSelectionHeight = (is.actualSelectionHeight > is.max_height) ? is.max_height : is.actualSelectionHeight;
            is.percentX1 = parseFloat(100 * (x1 / $('#image_for_selection').width()));
            is.actualSelectionX1 = parseFloat(is.img_width * (is.percentX1 / 100));
            is.percentY1 = parseFloat(100 * (y1 / $('#image_for_selection').height()));
            is.actualSelectionY1 = parseFloat(is.img_height * (is.percentY1 / 100));
            is.actualSelectionX2 = parseFloat(parseFloat(is.actualSelectionX1) + parseFloat(is.actualSelectionWidth));
            is.actualSelectionX2 = (is.actualSelectionX2 > is.img_width) ? parseFloat(is.img_width) : is.actualSelectionX2;
            is.actualSelectionY2 = parseFloat(parseFloat(is.actualSelectionY1) + parseFloat(is.actualSelectionHeight));
            is.actualSelectionY2 = (is.actualSelectionY2 > is.img_height) ? parseFloat(is.img_height) : is.actualSelectionY2;
            var data = {};
            data.x1 = Math.round(is.actualSelectionX1);
            data.y1 = Math.round(is.actualSelectionY1);
            data.x2 = Math.round(is.actualSelectionX2);
            data.y2 = Math.round(is.actualSelectionY2);
            data.width = Math.round(is.actualSelectionWidth);
            data.height = Math.round(is.actualSelectionHeight);
            data.cropW = Math.round(viewportW * (is.percentW / 100));
            data.cropH = Math.round(viewportH * (is.percentH / 100));
            data.minW = Math.floor(is.min * (viewportW / is.img_width));
            data.minH = Math.floor(is.min * (viewportH / is.img_height));
            return data;
        }

        function restoreValues(x1, y1, width, height) {
            var data = {};
            var viewportW = $('#image_for_selection').width();
            var viewportH = $('#image_for_selection').height();
            data.x1 = Math.round(x1 * (viewportW / is.img_width));
            data.y1 = Math.round(y1 * (viewportH / is.img_height));
            data.width = Math.round(width * (viewportW / is.img_width));
            data.height = Math.round(height * (viewportH / is.img_height));
            data.x2 = data.x1 + data.width;
            data.y2 = data.y1 + data.height;
            return data;
        }

        function updatePanel(x1, y1, x2, y2, width, height) {
            $('#x1').val(x1);
            $('#y1').val(y1);
            $('#x2').val(x2);
            $('#y2').val(y2);
            $('#w').val(width);
            $('#h').val(height);
            var data = '<table class="is_data">';
            data += "<tr><td> x: </td><td>" + x1 + ", " + y1 + "</td><tr>";
            data += "<tr><td> y: </td><td>" + x2 + ", " + y2 + "</td><tr>";
            data += "<tr><td> w: </td><td>" + width + "</td><tr>";
            data += "<tr><td> h: </td><td>" + height + "</td><tr>";
            data += "</table>";
            $('#save_btn span').html(data);
            $('.save_selection').show();
        }
        setTimeout(function () {
            $(window).on('resize', function () {
                $('body').hide();
                window.location.href = window.location.href;
            });
        }, 2000);

    </script>
</head>
<body id="inner_page">
<div id="ajax_loading"></div>
<section class="container" id="image_area">
    <div class="section_title" style="margin-top: 15px;position: relative">
        <?php echo t("ΕΠΙΛΟΓΗ ΠΕΡΙΟΧΗΣ ΕΙΚΟΝΑΣ"); ?>
        <input type="button" value="<?php echo t("Κλείσιμο"); ?>" onclick="closeImageArea()" class="btn btn-inverse close_modal">
    </div>
    <?php
    if ($messages->hasErrors) {
        ?>
        <div class="group">
            <div class="grid-12">
                <?php
                $messages->printSystemMessages();
                ?>
            </div>
        </div>
    <?php
    } else {
    $img_info = getimagesize($imageFile);
    $w = $img_info[0];
    $h = $img_info[1];
    $max_width = ($maxWidth >= $w) ? $w : $maxWidth;
    $max_height = ($maxHeight >= $h) ? $max_width * ($maxHeight / $maxWidth) : $maxHeight;
    if ($max_height > $h) {
        $max_height = $h;
        $max_width = ($maxWidth >= $w) ? $max_height * ($maxWidth / $maxHeight) : $maxWidth;
    }
    ?>
        <script type="text/javascript">
            setTimeout(function () {
                $(function () {
                    $('#crops_select').on('change', function () {
                        var cropID = $(this).val();
                        var originalCropID = '<?php echo $originalCropID;?>';
                        var new_crop = (cropID != originalCropID) ? 1 : 0;
                        document.location.href = "image_area.php?sectionID=<?php echo $sectionID;?>&imageID=<?php echo $imageID;?>&new_crop=" + new_crop + "&cropID=" + cropID;
                    });
                    is.img_width = '<?php echo $w;?>';
                    is.img_height = '<?php echo $h;?>';
                    is.max_width = '<?php echo $max_width;?>';
                    is.max_height = '<?php echo $max_height;?>';
                    is.width = '<?php echo $maxWidth;?>';
                    is.height = '<?php echo $maxHeight;?>';
                    is.imgViewportWidth = $('#image_for_selection').width();
                    is.imgViewportHeight = $('#image_for_selection').height();
                    var percent = 100 * (is.max_width / is.img_width);
                    is.actualMaxWidth = Math.round(is.imgViewportWidth * (percent / 100));
                    percent = 100 * (is.max_height / is.img_height);
                    is.actualMaxHeight = Math.round(is.imgViewportHeight * (percent / 100));
                    is.minLimit = is.min * ($('#image_for_selection').width() / is.img_width);
                    is.minLimit = (is.minLimit > is.min) ? is.min : is.minLimit;
                    is.ias = $('#image_for_selection img').imgAreaSelect({
                        maxWidth: is.actualMaxWidth,
                        minWidth: is.minLimit,
                        minHeight: is.minLimit,
                        aspectRatio: aspect_ratio(is.width, is.height),
                        handles: true,
                        x1: 0,
                        y1: 0,
                        x2: is.actualMaxWidth,
                        y2: is.actualMaxHeight,
                        instance: true,
                        onSelectChange: function (img, selection) {
                            if (selection.x1 < 0 || selection.y1 < 0) { // do not permit negative values in positioning
                                $('body').hide();
                                window.location.href = window.location.href;
                                return;
                            }
                            if (selection.x2 > 0) {
                                updateSelection(selection);
                            }
                        },
                        onInit: function () {
                            <?php
                            if($id && !$new_crop){
                            $crops_results = $db->getRecord("select * from `crops_data` where `id`='$id'");
                            $x1 = $crops_results->x1;
                            $y1 = $crops_results->y1;
                            $x2 = $crops_results->x2;
                            $y2 = $crops_results->y2;
                            $width = $crops_results->width;
                            $height = $crops_results->height;
                            ?>
                            var data = restoreValues('<?php echo $x1;?>', '<?php echo $y1;?>', '<?php echo $width;?>', '<?php echo $height;?>');
                            is.ias.setSelection(data.x1, data.y1, data.x2, data.y2, true);
                            updatePanel('<?php echo $x1;?>', '<?php echo $y1;?>', '<?php echo $x2;?>', '<?php echo $y2;?>', '<?php echo $width;?>', '<?php echo $height;?>');
                            <?php
                            }else{
                            ?>
                            is.ias.setSelection(0, 0, is.actualMaxWidth, is.actualMaxHeight, true);
                            var data = getActualValues(0, 0, is.actualMaxWidth, is.actualMaxHeight);
                            updatePanel(0, 0, data.x2, data.y2, data.width, data.height);
                            <?php
                            }
                            ?>
                            is.ias.setOptions({show: true});
                            is.ias.update();
                        }
                    });
                });
            }, 500);
        </script>
        <div class="group">
            <div class="grid-9">
                <?php
                if (count($crops) > 1){
                    ?>
                    <div class="crops_select_container">
                        <select id="crops_select" class="listbox">
                            <?php
                            foreach ($crops as $crop) {
                                $selected = ($crop->id == $cropID) ? " selected" : "";
                                ?>
                                <option value="<?php echo $crop->id; ?>"<?php echo $selected; ?>><?php echo $crop->title; ?></option>
                                <?php
                            }
                            ?>
                        </select>
                    </div>
                    <?php
                }
                ?>
                <div id="image_for_selection">
                    <img src="<?php echo $imageFile; ?>">
                </div>
            </div>
            <div class="grid-3">
                <div id="save_btn">
                    <span><i style="color: grey;"><br><br><?php echo "Drag to make the selection"; ?></i></span>
                    <input type="hidden" id="x1" value="">
                    <input type="hidden" id="y1" value="">
                    <input type="hidden" id="x2" value="">
                    <input type="hidden" id="y2" value="">
                    <input type="hidden" id="w" value="">
                    <input type="hidden" id="h" value="">
                    <div style="clear:both;"></div>
                    <input value="<?php echo t("Αποθήκευση"); ?>" class="btn btn-success save_selection" onclick="saveSelection()" type="button">
                    <?php
                    if ($id) {
                        ?>
                        <input value="<?php echo t("Διαγραφή"); ?>" class="btn btn-danger save_selection" onclick="deleteSelection()" type="button">
                        <?php
                    }
                    ?>
                </div>
            </div>
        </div>
        <?php
    }
    ?>
</section>
</body>
</html>
