<?php
/*
Promotions Rules
this file is included by sections.php
*/
$which_rules = $content->getValue($section, $itemID, "which_rules", $langID);
$once_per_customer = (int)$content->getValue($section, $itemID, "once_per_customer", $langID);
$which_rules = ($which_rules) ? $which_rules : "all";
$catID = $db->getRecord("select catID from `$section` where id='$itemID'")->catID;
$rules = $eshop->getRules($catID);
$conditions = $eshop->getConditions();
?>
<link href="css/promotions.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="js/jquery.form.js"></script>
<script type="text/javascript">
    var conditions = [];
    odyshop.once_per_customer = <?php echo $once_per_customer;?>;
    <?php
    foreach($rules as $rule){
    $ruleID = $rule->id;
    $ruleName = $rule->name;
    $conds = $eshop->getConditionsByRule($ruleID);
    ?>
    conditions['<?php echo $ruleName;?>'] = [<?php echo implode(",", $conds);?>];
    <?php
    }
    ?>
    var templates = [];
    templates['product_price'] = "tplPromotionRuleTextfield";
    templates['order_subtotal'] = "tplPromotionRuleTextfield";
    templates['coupon_code'] = "tplPromotionRuleTextfield";
    templates['shipping_zip_code'] = "tplPromotionRuleTextfield";
    templates['total_products_in_cart'] = "tplPromotionRuleTextfield";
    templates['user_group'] = "tplPromotionRuleSelect";
    templates['shipping_country'] = "tplPromotionRuleSelect";
    templates['payment_method'] = "tplPromotionRuleSelect";
    templates['shipping_method'] = "tplPromotionRuleSelect";
    templates['categories'] = "tplPromotionRuleButton";
    templates['products'] = "tplPromotionRuleButton";

    var btns = [];
    btns['products'] = "<?php echo t("Προσθήκη προϊόντων");?>";
    btns['categories'] = "<?php echo t("Προσθήκη κατηγοριών");?>";

    var links = [];
    links['products'] = "getProducts.php?mode=grouped_products";
    links['categories'] = "getCategories.php?section=products";


    jQuery(function ($) {
        odyshop.warnRulesBeforeLeave = false;
        loadRules();
        window.addEventListener("beforeunload", function (e) {
            if (!odyshop.warnRulesBeforeLeave) return undefined;
            (e || window.event).returnValue = true;
            return true;
        });
        $('#once_per_customer').on('change', function(){
            $('#edit_delete').trigger('click'); // submit in order to save the changed value because user_group rule depends on this value
        });

    });

    function loadRules() {
        jQuery.ajax({
            type: "POST",
            url: "ajax_promotions.php",
            data: "zone=rules&action=load&promotionID=" +<?php echo $itemID;?>,
            async: false,
            success: function (response) {
                //console.log(response);
                response = jQuery.parseJSON(response);
                if (typeof(response) == "object") {
                    for (i in response) {
                        var record = response[i];
                        var ruleName = record.ruleName;
                        var ruleTitle = record.ruleTitle;
                        var ruleID = record.ruleID;
                        var conditionID = record.conditionID;
                        var value = record.value;
                        var items = record.items;
                        var quantities = restoreValues(record.quantities);
                        if (isValidName(ruleName)) {
                            if (ruleName == "products" || ruleName == "categories") items = restoreValues(items);
                            var template = $("#" + templates[ruleName]).html();
                            var elm = template.format(ruleName, ruleTitle, value);
                            clearLastTreeClasses();
                            $('#promotions_rules').append(elm);
                            setJS();
                            $('tr[data-name="' + ruleName + '"]').find('select[data-type="conditions"] option').each(function () {
                                if ($(this).attr('value') == conditionID) $(this).attr('selected', 'selected');
                            });
                            if (ruleName == "products") {
                                getProducts(items, quantities);
                                $('.item_quantity_products').show();
                            }
                            if (ruleName == "categories") {
                                getCategories(items);
                                $('.item_quantity_products').show();
                            }
                        }
                    }
                    if (!response.length) addRule();
                } else {
                    popup("Error: " + response, "popup-warning"); // ajax error
                }
            }
        });
    }

    function restoreValues(value) {
        var values = value.split("|");
        values.shift();
        values = values.join(",");
        return values;
    }

    function clearLastTreeClasses() {
        $('tr[data-rel="rule"]').each(function () {
            $(this).find('.tree_item_last').removeClass('tree_item_last');
        });
    }

    function addRule(ruleID) {
        if (!ruleID) {
            var hasAlreadyAdded = $('#select_rule').length > 0;
            if (hasAlreadyAdded) {
                if ($('tr[data-rel="rule"]').length > 3)    goto('select_rule');
                $('#select_rule').hide().show('fast'); // effect to focus on new rule select menu
                return false; // duplicate rules are not permitted
            }
            var template = $("#tplAddRule").html();
            clearLastTreeClasses();
            $('#promotions_rules').append(template);
            if ($('tr[data-rel="rule"]').length > 3) goto('select_rule');
            $('#select_rule').hide().show('fast'); // effect to focus on new rule select menu
            $('#select_rule').on("change", function () {
                addRule($(this).val());
            });
        } else {
            var name = $('#select_rule').find(':selected').attr('data-name');
            var title = $('#select_rule').find(':selected').text();
            var value = "";
            if (isValidName(name)) {
                odyshop.warnRulesBeforeLeave = true;
                var template = $("#" + templates[name]).html();
                var elm = template.format(name, title, value);
                $('#to_be_replaced').remove();
                $('#promotions_rules').append(elm);
                setJS();
            } else {
                $('#select_rule').val("");
                popup("<?php echo t("Ο κανόνας αυτός υπάρχει ήδη");?>", "popup-warning");
            }
        }
    }

    function setJS() {
        var tr = $('#promotions_rules>tr:last');
        if (!tr.length) return false;
        var conditions_select = tr.find('select[data-type="conditions"]');
        var hasConditions = conditions_select.length;
        var name = tr.attr("data-name");
        if (hasConditions) {
            var theseConditions = conditions[name];
            conditions_select.find('option').each(function () {
                if (jQuery.inArray(parseInt($(this).attr("value")), theseConditions) == -1) $(this).remove();
            });
            if (templates[name] == "tplPromotionRuleSelect") {
                var options_select = tr.find('select[data-type="options"]');
                var selectedID = options_select.attr('data-value');
                $('#ajax_loading').show();
                jQuery.ajax({
                    type: "GET",
                    url: "ajax_promotions.php",
                    data: "zone=rules&action=select&source=" + name + "&langID=<?php echo $langID;?>&selectedID=" + selectedID,
                    async: true,
                    success: function (response) {
                        //console.log(response);
                        if (response != "error") {
                            options_select.html(response);
                        } else {
                            popup("Error loading select options for " + name, "popup-warning");
                        }
                        $('#ajax_loading').hide();
                    }
                });
                if (name == 'user_group') {
                    if(odyshop.once_per_customer == 1) { // αν μια φορα ανα πελατη
                        setTimeout(function () {
                            if(options_select.val() == 2){ // και αν επιλεγμενη επιλογή είναι ο «Επισκέπτης»
                                options_select.val(4);// ορισμος ως επιλεγμενου το «Πελάτης λιανικής»
                            }
                        }, 100);
                    }
                    options_select.on('focus', function () {
                        previousOptionValue = this.value;
                    }).change(function () {
                        currentOptionValue = this.value;
                        if (currentOptionValue == 2) { // Μη καταχωρημένος επισκέπτης
                            if (odyshop.once_per_customer == 1) { // check if once_per_customer property has been set
                                popup("<?php echo t("Δεν μπορείτε να επιλέξετε την ομάδα «Επισκέπτης», όταν είναι ενεργοποιημένη η ιδιότητα «Μια φορά ανά πελάτη»");?>", "popup-warning");
                                $(this).val(previousOptionValue);
                            } else {
                                previousOptionValue = this.value; // Make sure the previousOptionValue is updated
                            }
                        }
                    });
                }
            }
            if (templates[name] == "tplPromotionRuleButton") {
                var add_btn = tr.find('a.add_items');
                add_btn.text(btns[name]).attr("href", links[name]);
                add_btn.on("focusin", function () {
                    $(this).fancybox({
                        afterClose: function () {
                            var IDs = odyshop.IDs;
                            odyshop.IDs = null;
                            if (IDs.length) {
                                var IDs = IDs.join(",");
                                if (name == "products") {
                                    getProducts(IDs);
                                    $('.item_quantity_products').show();
                                }
                                if (name == "categories") {
                                    getCategories(IDs);
                                    $('.item_quantity_products').show();
                                }
                            }
                        },
                        width: 900,
                        minHeight: 600,
                        maxWidth: '98%',
                        arrows: false,
                        type: 'iframe',
                        modal: true,
                        helpers: {
                            overlay: {
                                css: {
                                    'background': 'rgba(0, 0, 0, 0.8)'
                                }
                            },
                            title: null
                        }
                    });
                });
            }
        }
        // bind click event to activate rules
        $('#promotions_rules').find('span, select, input').each(function () {
            $(this).on("click", function () {
                $(this).parents('tr').removeClass("to_be_deleted");
            });
        });
        $('#bottom_buttons').show();
        $('#nothing_found').hide();
    }

    function isValidName(name) {
        if (!name) return false;
        var returnValue = true;
        $('tr[data-rel="rule"]').each(function () {
            if ($(this).attr("data-name") == name)    returnValue = false;
        });
        return returnValue;
    }

    function removeRule(elm) {
        var tr = $(elm).parents('tr');
        if (tr.hasClass("to_be_deleted")) {
            tr.removeClass("to_be_deleted").find('input, select').each(function () {
                $(this).attr("name", $(this).attr("data-varname"));
            });
        } else {
            odyshop.warnRulesBeforeLeave = true;
            tr.addClass("to_be_deleted").find('input, select').each(function () {
                $(this).attr("name", "");
            });
        }
        if (!$('#promotions_rules tr').length) addRule();
    }

    function removeItem(elm) {
        var tr = $(elm).closest('tr');
        tr.hide('fast', function () {
            $(this).remove();
            odyshop.warnRulesBeforeLeave = true;
            if (!$('#items_products .item_row').length) $('#items_products .no_data').show('fast');
            if (!$('#items_categories .item_row').length) $('#items_categories .no_data').show('fast');
        });

    }

    function getProducts(IDs, quantities) {
        if (typeof(quantities) == 'undefined') var quantities = "";
        if (quantities) quantities = quantities.split(",");
        jQuery.ajax({
            type: "POST",
            url: "ajax_promotions_products.php",
            data: "action=get&IDs=" + IDs,
            async: false,
            success: function (response) {
                //console.log(response);
                response = jQuery.parseJSON(response);
                if (typeof(response) == "object") {
                    for (i in response) {
                        var record = response[i];
                        var id = record.id;
                        var title = record.title;
                        var exists = false;
                        $('#items_products').find('.item_row').each(function () {
                            if ($(this).attr('data-id') == 'product-' + id) {
                                exists = true;
                                return false;
                            }
                        });
                        if (!exists) {
                            var quantity = quantities[i] || 1;
                            $('.no_data').hide();
                            var tr = $('<tr/>');
                            tr.attr('class', 'item_row');
                            tr.attr('data-id', 'product-' + id);
                            $('#items_products').append(tr);
                            tr.append($('<td><a href="../index.php?section=products&view=node&id=' + id + '" class="footer_link" target="_blank">' + title + '</a></td>'));
                            tr.append($('<td class="centered_quantity"><input id="quantity_' + id + '" type="text" class="item_quantity_products listbox" value="' + quantity + '" onkeypress="return onlyNumeric(this, event, false)" onchange="odyshop.warnRulesBeforeLeave = true;"><a href="javascript:void(0)" onclick="removeItem(this)" class="remove_item" title="Αφαίρεση"></a></td>'));
                        }
                    }
                } else {
                    popup("Error: " + response, "popup-warning"); // ajax error
                }
            }
        });
    }

    function getCategories(IDs) {
        jQuery.ajax({
            type: "POST",
            url: "ajax_promotions_categories.php",
            data: "IDs=" + IDs,
            async: false,
            success: function (response) {
                //console.log(response);
                response = jQuery.parseJSON(response);
                if (typeof(response) == "object") {
                    for (i in response) {
                        var record = response[i];
                        var id = record.id;
                        var title = record.title;
                        var path = record.path;
                        var exists = false;
                        $('#items_categories').find('.item_row').each(function () {
                            if ($(this).attr('data-id') == 'cat-' + id) {
                                exists = true;
                                return false;
                            }
                        });
                        if (!exists) {
                            $('.no_data').hide();
                            var tr = $('<tr/>');
                            tr.attr('class', 'item_row');
                            tr.attr('data-id', 'cat-' + id);
                            $('#items_categories').append(tr);
                            tr.append($('<td><a href="../index.php?section=products&view=list&catID=' + id + '" class="footer_link" target="_blank" title="' + path + '">' + title + '</a></td>'));
                            tr.append($('<td class="centered_quantity"><a href="javascript:void(0)" onclick="removeItem(this)" class="remove_item" title="Αφαίρεση"></a></td>'));
                        }
                    }
                } else {
                    popup("Error: " + response, "popup-warning"); // ajax error
                }
            }
        });
    }

    function savePromotionRules() {
        if ($('#nothing_found').is(':visible')) {
            popup("<?php echo t("Πρέπει να προσθέσετε τουλάχιστον ένα κανόνα");?>", "popup-warning");
            return false;
        }
        var errors = [];
        var categories = {};
        categories['id'] = [];
        var products = {};
        products['id'] = [];
        products['quantity'] = [];
        $('#items_categories tr.item_row').each(function () {
            categories.id.push($(this).attr("data-id").replace('cat-', ''));
        });
        $('#items_products tr.item_row').each(function () {
            var id = $(this).attr("data-id").replace('product-', '');
            products.id.push(id);
            products.quantity.push($('#quantity_' + id).val());
        });
        if (categories.id.length) $('#categories_items').val(JSON.stringify(categories));
        if (products.id.length) $('#products_items').val(JSON.stringify(products));
        $('tr[data-rel="rule"][data-type="options"]', 'tr[data-rel="rule"][data-type="value"]', 'tr[data-rel="rule"][data-type="items"]').each(function () {
            if (!$(this).parents('tr').hasClass("to_be_deleted")) { // ignore deleted rules
                if (!$(this).val()) {
                    var name = $(this).parents('tr').attr('data-name');
                    var title = "&nbsp;&nbsp;•&nbsp;&nbsp;" + $(this).parents('tr').find('span[data-rel="rule_title"]').text();
                    errors.push(title);
                }
            }
        });
        if (errors.length) {
            errors = errors.join("<br>", errors);
            popup("<?php echo t("Πρέπει να επιλέξετε μια τιμή για");?>:<br><br>" + errors, "popup-warning");
            return false;
        }
        var options = {
            url: 'ajax_promotions.php',
            type: 'post',
            success: function (responseText) {
                if (responseText == "ok") {
                    // delete any rules marked as to be deleted
                    $('.to_be_deleted').each(function () {
                        $(this).remove();
                    });
                    if (!$('#promotions_rules tr').length) {
                        $('#nothing_found').show();
                        $('#bottom_buttons').hide();
                    }
                    odyshop.warnRulesBeforeLeave = false;
                    popup("<?php echo t("Οι κανόνες ενημερώθηκαν με επιτυχία");?>", "popup-info");
                } else {
                    popup("Error: " + responseText, "popup-warning");
                }
            }
        };
        $('#rules_form').ajaxSubmit(options);
    }

</script>
<script type="text/template" id="tplAddRule">
    <tr data-rel="rule" id="to_be_replaced">
        <td class="tree_item tree_item_last">&nbsp;</td>
        <td class="promotion_title" colspan="4">
            <select class="listbox" id="select_rule">
                <option value="">-- <?php echo t("επιλέξτε κανόνα"); ?> --</option>
                <?php
                foreach ($rules as $rule) {
                    $rule_id = $rule->id;
                    $rule_title = $rule->title;
                    $rule_name = $rule->name;
                    ?>
                    <option data-name="<?php echo $rule_name; ?>" value="<?php echo $rule_id; ?>"><?php echo $rule_title; ?></option>
                    <?php
                }
                ?>
            </select>
        </td>
    </tr>
</script>
<script type="text/template" id="tplPromotionRuleTextfield">
    <tr data-rel="rule" data-name="{0}">
        <td class="tree_item tree_item_last"></td>
        <td class="promotion_title gradient_bg"><span data-rel="rule_title">{1}</span></td>
        <td class="gradient_bg">
            <select data-type="conditions" class="listbox" data-varname="conditions[{0}]" name="conditions[{0}]">
                <?php
                foreach ($conditions as $item) {
                    $c_id = $item->id;
                    $c_sign = $item->condition_sign;
                    $c_title = $item->title;
                    ?>
                    <option data-sign="<?php echo $c_sign; ?>" value="<?php echo $c_id; ?>"><?php echo $c_title; ?></option>
                    <?php
                }
                ?>
            </select>
        </td>
        <td class="gradient_bg">
            <input data-type="value" type="text" data-varname="conditions_values[{0}]" name="conditions_values[{0}]" class="listbox" value="{2}" onchange="odyshop.warnRulesBeforeLeave = true;">
        </td>
        <td class="promotion_remove"><a href="javascript:void(0)" onclick="removeRule(this)" class="small_icon small_icon_remove tooltip" title="<?php echo t("Αφαίρεση"); ?>"></a></td>
    </tr>
</script>
<script type="text/template" id="tplPromotionRuleSelect">
    <tr data-rel="rule" data-name="{0}">
        <td class="tree_item tree_item_last"></td>
        <td class="promotion_title gradient_bg"><span data-rel="rule_title">{1}</span></td>
        <td class="gradient_bg">
            <select data-type="conditions" class="listbox" data-varname="conditions[{0}]" name="conditions[{0}]">
                <?php
                foreach ($conditions as $item) {
                    $c_id = $item->id;
                    $c_sign = $item->condition_sign;
                    $c_title = $item->title;
                    ?>
                    <option data-sign="<?php echo $c_sign; ?>" value="<?php echo $c_id; ?>"><?php echo $c_title; ?></option>
                    <?php
                }
                ?>
            </select>
        </td>
        <td class="gradient_bg">
            <select data-type="options" data-value="{2}" class="listbox" data-varname="conditions_values[{0}]" name="conditions_values[{0}]" onchange="odyshop.warnRulesBeforeLeave = true;"></select>
        </td>
        <td class="promotion_remove"><a href="javascript:void(0)" onclick="removeRule(this)" class="small_icon small_icon_remove tooltip" title="<?php echo t("Αφαίρεση"); ?>"></a></td>
    </tr>
</script>
<script type="text/template" id="tplPromotionRuleButton">
    <tr data-rel="rule" data-name="{0}">
        <td class="tree_item tree_item_last"></td>
        <td class="promotion_title gradient_bg"><span data-rel="rule_title">{1}</span></td>
        <td colspan="2" class="gradient_bg">
            <select data-type="conditions" class="listbox" data-varname="conditions[{0}]" name="conditions[{0}]">
                <?php
                foreach ($conditions as $item) {
                    $c_id = $item->id;
                    $c_sign = $item->condition_sign;
                    $c_title = $item->title;
                    ?>
                    <option data-sign="<?php echo $c_sign; ?>" value="<?php echo $c_id; ?>"><?php echo $c_title; ?></option>
                    <?php
                }
                ?>
            </select>
            <input data-type="value" type="hidden" id="{0}_values" data-varname="conditions_values[{0}]" name="conditions_values[{0}]" value="{2}" onchange="odyshop.warnRulesBeforeLeave = true;">
            <input data-type="items" type="hidden" id="{0}_items" data-varname="conditions_items[{0}]" name="conditions_items[{0}]" value="" onchange="odyshop.warnRulesBeforeLeave = true;">
            <a class="add_items" href="" onclick="this.blur(); odyshop.warnRulesBeforeLeave = true;"></a>
            <table data-content="items" cellpadding="0" cellspacing="0" id="items_{0}">
                <thead>
                <tr>
                    <th class="item_name"><?php echo t("Ονομασία"); ?></th>
                    <th class="item_quantity_{0}"><?php echo t("Ελάχιστη ποσότητα"); ?></th>
                </tr>
                </thead>
                <tbody>
                <tr class="no_data">
                    <td colspan="2"><?php echo t("Δεν υπάρχουν δεδομένα"); ?></td>
                </tr>
                </tbody>
            </table>
        </td>
        <td class="promotion_remove"><a href="javascript:void(0)" onclick="removeRule(this)" class="small_icon small_icon_remove tooltip" title="<?php echo t("Αφαίρεση"); ?>"></a></td>
    </tr>
</script>
<div class="promotion_btn">
    <a href="javascript:void(0)" onclick="addRule()" class="add"><?php echo t("Προσθήκη κανόνα"); ?></a>
    <a href="javascript:void(0)" onclick="savePromotionRules()" class="save"><?php echo t("Αποθήκευση"); ?></a>
</div>
<div style="clear:both;"></div>
<form id="rules_form">
    <div class="promotion_description">
        <?php echo t("Ορίστε τους κανόνες που πρέπει να ισχύουν γι' αυτή την προώθηση αγοράς") . ". " . t("Μπορείτε να προσθέσετε όσους κανόνες χρειάζεται, ώστε αν επαληθευθεί η εφαρμογή τους, να ενεργοποιήσουν το καθορισμένο μπόνους") . "."; ?>
        <div id="rules_criteria">
            <select id="which_rules" name="which_rules">
                <option value="all"<?php if ($which_rules == "all") echo " selected"; ?>><?php echo t("Αν όλοι οι κανόνες", $langID, "rules_criteria"). " " .t("είναι σε ισχύ", $langID, "rules_criteria"); ?></option>
                <option value="any"<?php if ($which_rules == "any") echo " selected"; ?>><?php echo t("Αν οποιοσδήποτε κανόνας", $langID, "rules_criteria")." " .t("είναι σε ισχύ", $langID, "rules_criteria"); ?></option>
            </select>
        </div>
    </div>
    <div class="promotion_content">
        <table id="promotions_rules" cellpadding="0" cellspacing="0"></table>
        <input type="hidden" name="zone" value="rules">
        <input type="hidden" name="action" value="save">
        <input type="hidden" name="promotionID" value="<?php echo $itemID; ?>">
        <div id="nothing_found"><?php echo t("Δεν βρέθηκαν καταχωρημένοι κανόνες"); ?></div>
    </div>
</form>
<div id="bottom_buttons">
    <div class="promotion_btn">
        <a href="javascript:void(0)" onclick="addRule()" class="add"><?php echo t("Προσθήκη κανόνα"); ?></a>
        <a href="javascript:void(0)" onclick="savePromotionRules()" class="save"><?php echo t("Αποθήκευση"); ?></a>
    </div>
    <div style="clear:both;"></div>
</div>
