<?php
/*
Odyshop products default controller file
$this is a reference to $document
*/

global $library;
foreach ($library as $class) global ${$class}; // import library classes
global $langID;
$sectionID = $this->sectionID;
$_SESSION['sectionCssFile'] = $this->getTemplatePath() . $this->cssFilePath . $this->section . ".css";
$sectionJsFile = $this->getTemplatePath() . $this->jsFilePath . $this->section . ".js";
$sectionJsReadyFile = $this->getTemplatePath() . $this->jsFilePath . $this->section . "_ready.js";

// get js & css files from db for this section
$record = $db->getRecord("select jsFiles, cssFiles from sections where id='$sectionID'");
$registeredJsFiles = explode(PHP_EOL, $record->jsFiles);
$registeredCssFiles = explode(PHP_EOL, $record->cssFiles);

// add any other scripts that have been registered for this section
$jsFiles = array();
foreach ($registeredJsFiles as $jsFile) {
    list($prefix, $filename) = explode("|", $jsFile);
    if ($prefix == "system") $jsFile = $this->jsFilePath . $filename;
    if ($prefix == "template") $jsFile = $this->getTemplatePath() . $this->jsFilePath . $filename;
    $jsFiles[] = $jsFile;
}
$jsFiles = $variables->removeEmptyRows($jsFiles);


// add any other css files that have been registered for this section
$cssFiles = array();
foreach ($registeredCssFiles as $cssFile) {
    list($prefix, $filename) = explode("|", $cssFile);
    if ($prefix == "system") $cssFile = $this->cssFilePath . $filename;
    if ($prefix == "template") $cssFile = $this->getTemplatePath() . $this->cssFilePath . $filename;
    $cssFiles[] = $cssFile;
}
$cssFiles = $variables->removeEmptyRows($cssFiles);


$thisView = $this->view;
$auth = new authentication(false);
$login = $auth->getLoginStatus() != 2;
$order[$this->defaultIndex] = "sort";
if ($system->getSectionProperty($this->section, "sortType")) $order[$this->section] = "sort";
$custom_order = ''; // reset
$presults = (int)$presults;
$ppage = (int)$ppage;
if ($_REQUEST['custom_order'] == 1) $custom_order = "products.id DESC";
if ($_REQUEST['custom_order'] == 2 || empty($_REQUEST['custom_order'])) $custom_order = "content_products.title ASC"; // alphabetically
if ($_REQUEST['custom_order'] == 3) $custom_order = "products.price ASC";
if ($_REQUEST['custom_order'] == 4) $custom_order = "products.price DESC";
if ($_REQUEST['custom_order'] == 5) $custom_order = "products.views DESC, products.id DESC";

if (in_array($thisView, array('list', 'search', $this->defaultIndex))) {


    $doNotPassData = false;
    $submitExists = false;

    foreach ($safeRequest as $key => $value) {
        if (preg_match('/_from$/i', $key) || preg_match('/_to$/i', $key)) ${$key} = urldecode(${$key});
        if ($thisView == "search") {
            if (preg_match('/submit/i', $key)) $submitExists = true;
            if (preg_match('/submit/i', $key) && empty(${$key})) $doNotPassData = true; // do not proceed searching if no submit value is present
        }
    }
    if ($thisView == "search" && !$submitExists) $doNotPassData = true; // do not proceed searching if no submit action is present
    $frecords = $db->getRecords("select fieldVarName, fieldDescription, fieldType, selectType, selectTableSectionName, isMainTitle 
												from `fields` 
												where tableSectionID='$sectionID' 
												and access='0' 
												order by sort");
    if (!count($frecords)) {
        $messages->addError(t("Δεν βρέθηκαν καταχωρημένα πεδία σε αυτή την ενότητα"));
        $doNotPassData = true;
    }

    // start building the query...
    $statuses = array();
    $cityExists = false;
    $countyExists = false;
    if (isset($catID) && empty($catID)) unset($catID);
    if ($thisView == "list" && !isset($catID)) $catID = 0;

    foreach ($frecords as $field) {
        $fieldVarName = $field->fieldVarName;
        $fieldDescription = $field->fieldDescription;
        $fieldType = $field->fieldType;
        $selectType = $field->selectType;
        $selectTableSectionName = $field->selectTableSectionName;
        $isMainTitle = $field->isMainTitle;
        if ($field->fieldVarName == "cityID") $cityExists = true;
        if ($field->fieldVarName == "countyID") $countyExists = true;
        $status = $system->getFieldStatus($fieldVarName, $sectionID)->status;
        $multi = ($fieldType == "selectList") ? "_multi" : NULL;
        if ($status) $statuses[$fieldVarName] = $status . $multi;
    }

    $searchForCategories = array();
    $searchForNumbers = array();
    $searchForDates = array();
    $searchForFlags = array();
    $searchForSections = array();
    $brands_array = array();
    $variants_array = array();
    $queries = array();
    $joins = array("content_products");
    $join_selectlists = array();
    $join_content_products = array();

    foreach ($statuses as $key => $value) {  // search for categories
        if (preg_match('/^category/', $value)) $searchForCategories[] = $key;
        if (isset(${$key})) {
            if (preg_match('/^category/', $value)) { // category
                if (!($thisView == "search" && empty(${$key}))) { // in case of search without category criteria don not include category value
                    if (preg_match('/_multi$/', $value)) { // one to many relation
                        if (!in_array("selectlists", $joins)) $joins[] = "selectlists";
                        $fieldID = $system->getFieldID($key, $sectionID);
                        $subCategories = $categories->getSubCategories(${$key});
                        $hasSubcategories = count($subCategories);
                        if ($hasSubcategories) {
                            foreach ($subCategories as $subCategory) $subCategoriesIDs [] = $subCategory->id;
                            $children = $categories->getChildren($subCategoriesIDs);
                            if (count($children)) {
                                $join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID IN (" . implode(',', $children) . "))";
                            } else {
                                $join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='" . ${$key} . "')";
                            }
                        } else {
                            $join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='" . ${$key} . "')";
                        }
                    } else { // one to one relation
                        $queries[] = "products." . $key . "='" . ${$key} . "'";
                    }
                }
            }
        }
    }


    $keyword = (preg_match('/^' . t("Αναζήτηση") . '/', $keyword)) ? NULL : $keyword;
    if ($keyword) {
        $foundKeyword = false;
        $foundMLKeyword = false;
        $q = "";
        $qML = "";
        foreach ($statuses as $key => $value) { // search for keywords
            if ($value == "keyword") {
                $isMultilingual = $system->isMultilingualField($key, $sectionID);

                if ($isMultilingual == "1" || $key == "code") {
                    $concat = (!$foundMLKeyword) ? "(" : " or ";
                    if ($key != "code") {
                        $qML .= $concat . "content_products." . $key . " like '%" . $keyword . "%'";
                    } else {
                        $qML .= $concat . "products." . $key . " like '%" . $keyword . "%'";
                    }
                    $foundMLKeyword = true;

                } else {
                    if ($key != "code") {
                        $concat = (!$foundKeyword) ? "(" : " or ";
                        $q .= $concat . "products." . $key . " like '%" . $keyword . "%'";
                        $foundKeyword = true;
                    }
                }
            }
        }
        if ($foundKeyword) {
            $q .= ")";
            $queries[] = $q;
        }
        if ($foundMLKeyword) {
            $qML .= ")";
            $join_content_products[] = $qML;
        }
    }
    if ($prices) {
        list($price_from, $price_to) = explode("|", $prices);
        $include_vat = (int)$parameters->getParameter("include_vat");
        if ($include_vat) {
            $vat = $content->getValue("fpa_cat", $parameters->getParameter("default_vat"), "percent", $langID);
            $factor = 1 + (float)($vat / 100);
            $price_from = floor($price_from / $factor);
            $price_to = ceil($price_to / $factor);
        }
    }
    if ($brands) {
        $brands_array = explode("|", $brands);
        $brandIDs = implode(",", $brands_array);
    }
    if ($variants) {
        $variants_array = explode("|", $variants);
        $variantIDs = implode(",", $variants_array);
    }


    $isNumRange = false;
    foreach ($statuses as $key => $value) {  // search for numbers
        if ($value == "number") $searchForNumbers[] = $key;
        if (isset(${$key}) || isset(${$key . "_from"}) || isset(${$key . "_to"})) {
            if ($value == "number") {
                if (${$key . "_from"}) { // starting limit value of a range
                    $queries[] = "products." . $key . " >= " . ${$key . "_from"};
                    $isNumRange = true;
                }
                if (${$key . "_to"}) { // ending limit value of a range
                    $queries[] = "products." . $key . " <= " . ${$key . "_to"};
                    $isNumRange = true;
                }
                if (${$key . "_from"} && ${$key . "_to"}) { // check for valid range values
                    $fieldDescription = $system->getFieldDescription($key, $sectionID);
                    if (${$key . "_from"} > ${$key . "_to"}) {
                        $messages->addError(sprintf(t("Σφάλμα στο πεδίο") . " [%s]:", $fieldDescription));
                        $messages->addError(t("Η τιμή «από» πρέπει να είναι μικρότερη ή ίση της τιμής «έως»"));
                    }
                }
                if (!$isNumRange && !empty(${$key})) { // just return equality
                    $queries[] = "products." . $key . " = " . ${$key};
                }
            }
        }
    }

   // if ($isNumRange) $queries[] = "products.price > 0";

    foreach ($statuses as $key => $value) {  // search for flags (checkboxes)
        if ($value == "flag") $searchForFlags[] = $key;
        if (isset(${$key})) {
            if ($value == "flag" && !empty(${$key})) {
                $queries[] = "products." . $key . " = 1";
            }
        }
    }

    foreach ($statuses as $key => $value) {  // search for section releations
        if ($value == "section" || $value == "section_multi") $searchForSections[] = $key;
        if (isset(${$key}) && !empty(${$key})) {
            if ($value == "section" || $value == "section_multi") {
                if (preg_match('/_multi$/', $value)) { // one to many relation
                    if (!in_array("selectlists", $joins)) $joins[] = "selectlists";
                    $fieldID = $system->getFieldID($key, $sectionID);
                    $join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='" . ${$key} . "')";
                } else { // one to one relation
                    $queries[] = "products." . $key . "='" . ${$key} . "' ";
                }
            }
        }
    }

    if ($brandIDs) $queries[] = "products.brandID IN (" . $brandIDs . ")";
    if ($variantIDs) $productIDs = $eshop->getProductsByFilters($variantIDs);

    $masterQuery = "select distinct products.id from products";
    foreach ($joins as $join) {
        $masterQuery .= " join " . $join . " on ";
        if ($join == "content_products") $masterQuery .= "content_products.mainID=products.id and content_products.title <> '' and content_products.langID='" . $langID . "'";
        $index = 0;
        $count = count(${"join_" . $join});
        foreach (${"join_" . $join} as $join_query) {
            if ($join == "content_products") $masterQuery .= " and ";
            $masterQuery .= $join_query;
            if (($index + 1) < $count) {
                $masterQuery .= " and ";
            }
            $index++;
        }
    }

    $masterQuery .= " where products.active=1 ";
    foreach ($queries as $query) {
        $masterQuery .= " and " . $query . " ";
    }

    if ($productIDs) $masterQuery .= "and products.id IN (" . $productIDs . ")";


    $pIDs = $db->getRecords($masterQuery);
    // exclude IDs
    $excludedIDs = array();
    $IDs = array();
    foreach ($pIDs as $record) {
        $hasAccess = $eshop->hasAccess($record->id);
        if (!$hasAccess) {
            $excludedIDs[] = $record->id;
        } else {
            $IDs[] = $record->id;
        }
    }
    //debug($masterQuery);

    $numOfAllItems = count($pIDs) - count($excludedIDs);
    $excludedIDs = implode(",", $excludedIDs);
    $IDs = (count($IDs) > 100) ? "" : implode(",", $IDs); // limit set navigation to max 100 items for GET
    if ($variantIDs && !$productIDs) $numOfAllItems = 0;

    if ($numOfAllItems) {
        $queries = array();
        $joins = array("content_products");
        $join_selectlists = array();
        $join_features = array();
        $join_content_products = array();
        foreach ($statuses as $key => $value) {  // search for categories
            if (preg_match('/^category/', $value)) $searchForCategories[] = $key;
            if (isset(${$key})) {
                if (preg_match('/^category/', $value)) { // category
                    if (!($thisView == "search" && empty(${$key}))) { // in case of search without category criteria don not include category value
                        if (preg_match('/_multi$/', $value)) { // one to many relation
                            if (!in_array("selectlists", $joins)) $joins[] = "selectlists";
                            $fieldID = $system->getFieldID($key, $sectionID);
                            $subCategories = $categories->getSubCategories(${$key});
                            $hasSubcategories = count($subCategories);
                            if ($hasSubcategories) {
                                foreach ($subCategories as $subCategory) $subCategoriesIDs [] = $subCategory->id;
                                $children = $categories->getChildren($subCategoriesIDs);
                                if (count($children)) {
                                    $join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID IN (" . implode(',', $children) . "))";
                                } else {
                                    $join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='" . ${$key} . "')";
                                }
                            } else {
                                $join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='" . ${$key} . "')";
                            }
                        } else { // one to one relation
                            $queries[] = "products." . $key . "='" . ${$key} . "'";
                        }
                    }
                }
            }
        }

        $keyword = (preg_match('/^' . t("Αναζήτηση") . '/', $keyword)) ? NULL : $keyword;
        if ($keyword) {
            $foundKeyword = false;
            $foundMLKeyword = false;
            $q = "";
            $qML = "";
            foreach ($statuses as $key => $value) { // search for keywords
                if ($value == "keyword") {
                    $isMultilingual = $system->isMultilingualField($key, $sectionID);

                    if ($isMultilingual == "1" || $key == "code") {
                        $concat = (!$foundMLKeyword) ? "(" : " or ";
                        if ($key != "code") {
                            $qML .= $concat . "content_products." . $key . " like '%" . $keyword . "%'";
                        } else {
                            $qML .= $concat . "products." . $key . " like '%" . $keyword . "%'";
                        }
                        $foundMLKeyword = true;

                    } else {
                        if ($key != "code") {
                            $concat = (!$foundKeyword) ? "(" : " or ";
                            $q .= $concat . "products." . $key . " like '%" . $keyword . "%'";
                            $foundKeyword = true;
                        }
                    }
                }
            }
            if ($foundKeyword) {
                $q .= ")";
                $queries[] = $q;
            }
            if ($foundMLKeyword) {
                $qML .= ")";
                $join_content_products[] = $qML;
            }
        }

        if ($prices) {
            list($price_from, $price_to) = explode("|", $prices);
            $include_vat = (int)$parameters->getParameter("include_vat");
            if ($include_vat) {
                $vat = $content->getValue("fpa_cat", $parameters->getParameter("default_vat"), "percent", $langID);
                $factor = 1 + (float)($vat / 100);
                $price_from = floor($price_from / $factor);
                $price_to = ceil($price_to / $factor);
            }
        }
        if ($brands) {
            $brands_array = explode("|", $brands);
            $brandIDs = implode(",", $brands_array);
        }
        if ($variants) {
            $variants_array = explode("|", $variants);
            $variantIDs = implode(",", $variants_array);
        }


        $isNumRange = false;
        foreach ($statuses as $key => $value) {  // search for numbers
            if ($value == "number") $searchForNumbers[] = $key;
            if (isset(${$key}) || isset(${$key . "_from"}) || isset(${$key . "_to"})) {
                if ($value == "number") {
                    if (${$key . "_from"}) { // starting limit value of a range
                        $queries[] = "products." . $key . " >= " . ${$key . "_from"};
                        $isNumRange = true;
                    }
                    if (${$key . "_to"}) { // ending limit value of a range
                        $queries[] = "products." . $key . " <= " . ${$key . "_to"};
                        $isNumRange = true;
                    }
                    if (${$key . "_from"} && ${$key . "_to"}) { // check for valid range values
                        $fieldDescription = $system->getFieldDescription($key, $sectionID);
                        if (${$key . "_from"} > ${$key . "_to"}) {
                            $messages->addError(sprintf(t("Σφάλμα στο πεδίο") . " [%s]:", $fieldDescription));
                            $messages->addError(t("Η τιμή «από» πρέπει να είναι μικρότερη ή ίση της τιμής «έως»"));
                        }
                    }
                    if (!$isNumRange && !empty(${$key})) { // just return equality
                        $queries[] = "products." . $key . " = " . ${$key};
                    }
                }
            }
        }

        //if ($isNumRange) $queries[] = "products.price > 0";

        foreach ($statuses as $key => $value) {  // search for flags (checkboxes)
            if ($value == "flag") $searchForFlags[] = $key;
            if (isset(${$key})) {
                if ($value == "flag" && !empty(${$key})) {
                    $queries[] = "products." . $key . " = 1";
                }
            }
        }

        foreach ($statuses as $key => $value) {  // search for section releations
            if ($value == "section" || $value == "section_multi") $searchForSections[] = $key;
            if (isset(${$key}) && !empty(${$key})) {
                if ($value == "section" || $value == "section_multi") {
                    if (preg_match('/_multi$/', $value)) { // one to many relation
                        if (!in_array("selectlists", $joins)) $joins[] = "selectlists";
                        $fieldID = $system->getFieldID($key, $sectionID);
                        $join_selectlists[] = "(selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=$section.id and selectlists.optionID='" . ${$key} . "')";
                    } else { // one to one relation
                        $queries[] = "products." . $key . "='" . ${$key} . "' ";
                    }
                }
            }
        }

        if ($brandIDs) $queries[] = "products.brandID IN (" . $brandIDs . ")";


        // if the current user is unregistered or the loged user has level One permissions (just commenting and viewing only public content) exclude private content from query
        if (!$login || $login == 1) $queries[] = "products.private=1 "; // private=1 equals to public records
/*
        $q2 = "select min(products.price) as min_price, max(products.price) as max_price from products, selectlists where 1 ";
        if ($catID) {
            $fieldID = $system->getFieldID("catID", $sectionID);
            $q2 .= "and (selectlists.sectionID='$sectionID' and selectlists.fieldID='$fieldID' and selectlists.itemID=products.id and selectlists.optionID='" . $catID . "') ";
        }
        if ($excludedIDs) $q2 .= "and products.id NOT IN (" . $excludedIDs . ")";
        $price_limits = $db->getRecord($q2);
        $min_price = $price_limits->min_price;
        $max_price = $price_limits->max_price;
*/
        $presults = $system->getPresults($section);
        $page = $ppage;
        $maxrows = $numOfAllItems;
        $page = ($page > 0) ? $page : 1;
        $startrecord = ($page * $presults) - $presults;
        $startrecord = ($startrecord < 0) ? 0 : $startrecord;

        $masterQuery = "select distinct products.* "; // start building the final query
        foreach ($frecords as $frecord) {
            $isMultilingual = $system->isMultilingualField($frecord->fieldVarName, $sectionID);
            if ($isMultilingual) $masterQuery .= ", content_" . $section . "." . $frecord->fieldVarName;
        }
        $masterQuery .= " from products ";
        if (!$hasSubcategories && $excludedIDs) $queries[] = "products.id NOT IN (" . $excludedIDs . ") ";

        foreach ($joins as $join) {
            $masterQuery .= " join " . $join . " on ";
            if ($join == "content_products") $masterQuery .= "content_products.mainID=products.id and content_products.title <> '' and content_products.langID='" . $langID . "'";
            $index = 0;
            $count = count(${"join_" . $join});
            foreach (${"join_" . $join} as $join_query) {
                if ($join == "content_products") $masterQuery .= " and ";
                $masterQuery .= $join_query;
                if (($index + 1) < $count) {
                    $masterQuery .= " and ";
                }
                $index++;
            }
        }
        $masterQuery .= " where products.active=1 ";
        foreach ($queries as $query) {
            $masterQuery .= " and " . $query . " ";
        }

        if ($productIDs) $masterQuery .= "and products.id IN (" . $productIDs . ")";
        $pricesQuery = explode("from products", $masterQuery);
        $prices_result = $db->getRecord("select min(products.price) as min_price, max(products.price) as max_price from products " . $pricesQuery[1]);
        $min_price = $prices_result->min_price;
        $max_price = $prices_result->max_price;
        $order = (!empty($order[$section])) ? $section . "." . $order[$section] : $section . ".id DESC, content_" . $section . ".title";
        $order = ($custom_order) ? $custom_order : $order;
        $masterQuery .= " order by " . $order . " LIMIT $startrecord, $presults";
        //debug($masterQuery);
        //die($masterQuery);

        $items = $db->getRecords($masterQuery);

    } else {
        $numOfAllItems = 0;
        $items = $catItems; // return the subcategories object
    }
    if (!$numOfAllItems) $messages->addMessage(t("Δεν βρέθηκαν καταχωρημένα προϊόντα"));
}


$views = array();
$viewsFiles = $this->getTemplatePath() . 'view_' . $this->section . '_*.php';
foreach (glob($viewsFiles) as $viewFile) {
    if (is_file($viewFile)) {
        if (!preg_match('/_list.php$/', $viewFile) && !preg_match('/_search.php$/', $viewFile)) {
            $baseName = explode("_", $fileSystem->getFileBaseName($viewFile));
            $views[] = end($baseName);
        }
    }
}


if (in_array($thisView, $views)) {
    $id = (int)$id;
    $item = $content->getContentByID($this->section, $id, "*", "*", $langID);
    $item->id = $id;
    $multi_categories = $categories->getMultiCategories($this->sectionID, $id);
    if (!$item) $messages->addError(t("Η συγκεκριμένη εγγραφή δεν βρέθηκε"));
}

// manage ready javascript for this section
$this->javascript_ready = NULL;
ob_start();
// javascript ready code will be included in js ready section below
?>

    $('<a/>', {
    id: 'after_basket',
    class: 'hidden',
    href: 'after_basket.php?langID=<?php echo $langID; ?>'
    }).appendTo("body");

    $('.product_wrapper').on("mouseover", function(){
    $(this).find(".quick_view").show();
    }).on("mouseout", function(){
    $(this).find(".quick_view").hide();
    });

    $('.price_range').keyup(function (e) {
    if (e.keyCode == 13) {
    $(this).blur();
    }
    });

    setTimeout(function(){
    $('#price_range').find('a').each(function(){
    $(this).addClass("rainbow");
    });
    }, 50);

    $('.quick_view').fancybox({
    width : 800,
    height: 700,
    maxHeight : 700,
    type : 'iframe',
    arrows: false,
    modal: true,
    helpers : {
    overlay : {
    css : {
    'background' : 'rgba(0, 0, 0, 0.8)'
    }
    },
    title: null
    }
    });

    $('#after_basket').fancybox({
    width : 680,
    height: 400,
    maxHeight : 400,
    type : 'iframe',
    arrows: false,
    modal: true,
    helpers : {
    overlay : {
    css : {
    'background' : 'rgba(0, 0, 0, 0.8)'
    }
    },
    title: null
    }
    });

    $('.pagination a').on("click", function(event){
    event.preventDefault();
    var params = $(this).attr("data-params") +"&langID=" + window.langID;
    $('#ajax_loading').show();
    updateProducts(params);
    });

    $('#custom_order').on("change", function(event){
    var custom_order = $(this).val();
    var ppage = $(this).attr("data-page");
    var presults = $(this).attr("data-presults");
    var catID = $(this).attr("data-catID");
    var params = "&section=products&view=list&custom_order=" + custom_order + "&ppage=" +ppage + "&presults=" + presults + "&langID=" + window.langID;
    if(catID) params += "&catID=" + catID;
    params += getFilters();
    updateProducts(params);
    });

    $('.filter_contents').find('.filter_switch').each(function(){
    $(this).on("click", function(event){
    var params = $('#qstring').val() + getFilters();
    var toBeReplaced = "&ppage=<?php echo $ppage; ?>";
    params = params.replace(toBeReplaced, "");
    updateProducts(params);
    });
    });
    /*
    // prevent query string on load in order to load filters corectly
    function getQueryStringValue (key) {
    return unescape(window.location.search.replace(new RegExp("^(?:.*[&\\?]" + escape(key).replace(/[\.\+\*]/g, "\\$&") + "(?:\\=([^&]*))?)?.*$", "i"), "$1"));
    }
    if(getQueryStringValue("brands") !="" || getQueryStringValue("variants") !=""){
    //document.location = location.pathname;
    }
    */
<?php

$this->javascript_ready = ob_get_clean();


// manage javascript for each view
$this->javascript = NULL;
ob_start();

switch ($thisView) {

    case "node":
        $product = $item;
        if ($product) {
            $eshop->increaseProductViews($product->id);
            $defaultBasketName = ($login) ? "basket" : "session";
            global $protocol;
            $inventory_type = $product->inventory_type;
            $instock = $product->instock;
            $currency = $eshop->getCurrency();
            $currency_sign = $currency->sign;
            $currency_code = $currency->code;
            $currency_start_position = $currency->start_position;
            $currency_decimal = $currency->decimal;
            $currency_decimal_seperator = $currency->decimal_seperator;
            $currency_thousands_seperator = $currency->thousands_seperator;
            ?>
            <script type="text/javascript">
                odyshop.currency = {
                    sign: "<?php echo $currency_sign;?>",
                    code: "<?php echo $currency_code;?>",
                    start_position: "<?php echo $currency_start_position;?>",
                    decimal: "<?php echo $currency_decimal;?>",
                    decimal_seperator: "<?php echo $currency_decimal_seperator;?>",
                    thousands_seperator: "<?php echo $currency_thousands_seperator;?>"
                };
                odyshop.optionImage = false;
                jQuery(document).ready(function ($) {
                    $('#tabs').on('click', function () {
                        $(window).trigger('resize');
                    });
                    $("a[data-rel=\'qv_image\']").fancybox({
                        "overlayOpacity": 0.9,
                        "overlayColor": "#000",
                        "transitionIn": "elastic",
                        "transitionOut": "elastic",
                        "nextEffect": "fade",
                        "prevEffect": "fade"
                    });
                    $('a[data-image]').each(function () {
                        $(this).on('click', function () {
                            if ($(this).hasClass('qv_thumb_active')) return false;
                            $('.qv_thumb').removeClass("qv_thumb_active");
                            $(this).addClass("qv_thumb_active");
                            var image = $(this).attr('data-image');
                            var caption = $(this).attr('data-caption');
                            $('#qv_current_image').fadeToggle("fast", function () {
                                $('#qv_current_image').attr("src", "mediabank/medium/medium_" + image);
                                $('#qv_current_image_link').attr("href", "mediabank/images/" + image).attr("title", caption).fancybox({
                                    "overlayOpacity": 0.9,
                                    "overlayColor": "#000",
                                    "transitionIn": "elastic",
                                    "transitionOut": "elastic",
                                    "nextEffect": "fade",
                                    "prevEffect": "fade"
                                });
                                $('#qv_current_image').fadeToggle("fast");
                            });
                        });
                    });
                    $('.interactive_option').each(function (idx) {
                        $(this).on("change", function () {
                            var id = $(this).attr('id').replace("option_", "");
                            var parts = id.split("_");
                            var optionID = parts[0];
                            var productID = parts[1];
                            var variantID = $(this).val();
                            var combination = getCombination();
                            var inventory_type = "<?php echo $inventory_type;?>";
                            updateOptionSelects(productID);
                            $('#ajax_loading').show();
                            jQuery.ajax({
                                type: "GET",
                                url: "ajax_options.php",
                                data: "productID=" + productID + "&optionID=" + optionID + "&variantID=" + variantID + "&combination=" + combination + "&langID=<?php echo $langID;?>",
                                async: false,
                                success: function (response) {
                                    //console.log(response);
                                    if (response.indexOf("ok_") != -1) {
                                        var response = response.replace("ok_", "");
                                        if (response == "empty") return; // do nothing
                                        var parts = response.split("_");
                                        var include_vat = parseInt($('#include_vat').val());
                                        var vat = parseFloat($('#vat').val());
                                        var amount;
                                        var type;
                                        var prices = parts[0];
                                        var code = parts[2];
                                        var quantity = !parts[3] ? 0 : parts[3];
                                        var availability = (parseInt(quantity)) ? "<?php echo t("Σε Απόθεμα"); ?>" : "<?php echo t("Μη Διαθέσιμο");?>";
                                        if (inventory_type == "2" && !quantity) availability = "<?php echo t("Μη διαθέσιμο σε αυτό τον συνδυασμό");?>";
                                        if (parseInt(inventory_type) < 3) { // manage availability (3 = no inventory)
                                            if (parseInt(inventory_type) == 1) quantity = "<?php echo $instock;?>";
                                            var availability = (parseInt(quantity)) ? "<?php echo t("Σε Απόθεμα"); ?>" : "<?php echo t("Μη Διαθέσιμο");?>";
                                            if (inventory_type == "2" && !quantity) availability = "<?php echo t("Μη διαθέσιμο σε αυτό τον συνδυασμό");?>";
                                            var availability_class = (parseInt(quantity)) ? "qv_green" : "qv_red";
                                            $('#inventory').removeClass("qv_green qv_red").addClass(availability_class).html(availability);
                                        }
                                        code = (code) ? code : $('#qv_code').attr('data-code');
                                        $('#qv_code').html(code);
                                        prices = prices.split("~");
                                        var basePrice = parseFloat($('#qv_price').attr('data-baseprice'));
                                        if(include_vat) basePrice = roundDecimal(basePrice);
                                        var price = basePrice;
                                        var modified_price = 0;
                                        for (i in prices) {
                                            var price_parts = prices[i].split("|");
                                            amount = parseFloat(price_parts[0]);
                                            type = price_parts[1];
                                            if (amount) { // price actions
                                                if (type == "A") {
                                                    if (include_vat) amount = includeVat(amount, vat);
                                                    modified_price += amount;
                                                    var price = parseFloat(basePrice + modified_price);
                                                    if(include_vat) price = roundDecimal(price);
                                                    $('#qv_price').html(formatPrice(parseFloat(basePrice + modified_price), odyshop.currency)).attr('data-price', price);
                                                }
                                                if (type == "P") {
                                                    var percent_amount = amount * (basePrice / 100);
                                                    modified_price += percent_amount;
                                                    var price = parseFloat(basePrice + modified_price);
                                                    if(include_vat) price = roundDecimal(price);
                                                    $('#qv_price').html(formatPrice(parseFloat(basePrice + modified_price), odyshop.currency)).attr('data-price', price);
                                                }
                                            } else { // restore original price
                                                $('#qv_price').html(formatPrice(basePrice, odyshop.currency));
                                            }
                                        }
                                        if(include_vat) price = roundDecimal(price);
                                        var list_price = parseFloat($('#list_price').attr('data-list_price'));
                                        var earning = list_price - price;
                                        var save_percent = parseInt((100 - (100 * (price / list_price))));
                                        $('#qv_price').html(formatPrice(price, odyshop.currency));
                                        $('#save_price').html(formatPrice(earning, odyshop.currency)).attr('data-save_price', earning);
                                        $('#save_percent').text(save_percent);
                                        $('.qv_save_price_percent').text(save_percent);
                                        var include_vat = $('#include_vat').val() == "1";
                                        if (!include_vat) {
                                            $('#qv_final_price').html("(" + formatPrice(includeVat(price, vat), odyshop.currency) + " " + t("με ΦΠΑ") + ")");
                                        }
                                        if (!prices[0]) {
                                            $('#qv_price').attr("data-price", $('#qv_price').attr("data-basePrice"));
                                            calculatePrice(<?php echo $id;?>);
                                        }

                                        var image = parts[1];
                                        if (image) { // manage image
                                            odyshop.optionImage = image;
                                            var big_image = "mediabank/images/" + image;
                                            $('#qv_current_image').parent().attr("href", big_image);
                                            image = "mediabank/medium/medium_" + image;
                                            $('#qv_current_image').attr("src", image);
                                        } else {
                                            if (!odyshop.optionImage) { // restore basic image
                                                var defaultImage = $('#qv_current_image').attr("data-image");
                                                var big_image = "mediabank/images/" + defaultImage;
                                                $('#qv_current_image').parent().attr("href", big_image);
                                                image = "mediabank/medium/medium_" + defaultImage;
                                                $('#qv_current_image').attr("src", image);
                                            }
                                        }
                                    } else {
                                        popup(response, "error", 5000);
                                    }
                                    $('#ajax_loading').hide();
                                }
                            });
                        });
                        if (!idx) $(this).change(); // fire change event only once to set parameters
                    });
                    $('#qv_content').attr({'data-productID':'<?php echo $id;?>', 'data-inventory_type':'<?php echo $inventory_type;?>', 'data-instock':'<?php echo $instock;?>'});
                });

                function updateOptionSelects(productID) {
                    var selectedOptions = $(".interactive_option").serializeArray();
                    if (!selectedOptions.length) return;
                    var selectedOptions = JSON.stringify(selectedOptions);
                    $('#ajax_loading').show();
                    jQuery.ajax({
                        type: "POST",
                        url: "ajax_exceptions.php",
                        data: "productID=" + productID + "&selectedOptions=" + selectedOptions + "&langID=<?php echo $langID;?>",
                        async: false,
                        success: function (response) {
                            //console.log(response);
                            response = jQuery.parseJSON(response);
                            if (typeof(response) == "object") {
                                for (optionID in response) {
                                    var thisOptions = response[optionID];
                                    var elm = $('#option_' + optionID + '_' + productID);
                                    elm.html(''); // empty existing options from select element
                                    for (i in thisOptions) {
                                        elm.append(thisOptions[i]);
                                    }
                                }
                            } else {
                                alert("Error in AJAX call: " + response); // ajax error
                            }
                            $('#ajax_loading').hide();
                        }
                    });
                }


                function getCombination() {
                    var value = "";
                    $('.interactive_option').each(function () {
                        var id = $(this).attr('id').replace("option_", "");
                        var parts = id.split("_");
                        var optionID = parts[0];
                        var variantID = $(this).val();
                        value += optionID + "|" + variantID + "_";
                    });
                    var hasUnderscore = new RegExp('(_)$');
                    if (hasUnderscore.test(value)) {
                        value = value.substring(0, value.length - 1);
                    }
                    if (value) $('#combination').val(value);
                    return value;
                }

                function addToBasket(basketTypeName) {
                    basketTypeName = (basketTypeName) ? basketTypeName : "<?php echo $defaultBasketName;?>";
                    var productID = '<?php echo $id;?>';
                    var quantity = $('#quantity').val();
                    var action = "add";
                    var combination = $('#combination').val();
                    $('#ajax_loading').show();
                    jQuery.ajax({
                        type: "GET",
                        url: "ajax_basket.php",
                        data: "productID=" + productID + "&quantity=" + quantity + "&action=" + action + "&combination=" + combination + "&basketTypeName=" + basketTypeName + "&langID=<?php echo $langID;?>",
                        async: false,
                        success: function (response) {
                            //console.log(response);
                            if (response.indexOf("ok~|~") != -1) {
                                var response = response.replace("ok~|~", "");
                                var notifications = response.split("~|~");
                                if (basketTypeName != "wishlist") {
                                    if (window.top.location != window.location) {
                                        parent.odyshop.notifications = notifications.join("<br>");
                                        parent.$('#after_basket').click();
                                        $('#ajax_loading').hide();
                                        return;
                                    } else {
                                        odyshop.notifications = notifications.join("<br>");
                                        $('#after_basket').click();
                                        $('#ajax_loading').hide();
                                        return;
                                    }
                                }
                            } else if (response.indexOf("error~|~") != -1) {
                                var response = response.replace("error~|~", "");
                                if (!response) {
                                    popup(response, "error", 5000);
                                } else {
                                    var errors = response.split("~|~");
                                    var timeout = errors.length - 1;
                                    if (errors.length) {
                                        errors = errors.join("<br>");
                                        popup(errors, "error", (5000 + (1000 * (timeout))));
                                    }
                                }
                            } else {
                                popup(response, "error", 5000);
                            }
                            $('#ajax_loading').hide();
                        }
                    });
                }

                function calculatePrice(productID) {
                    var combination = $('#combination').val();
                    var vat = $('#vat').val();
                    var quantity = parseInt($('#quantity').val());
                    checkAvailability('', quantity);
                    jQuery.ajax({
                        type: "GET",
                        url: "ajax_price.php",
                        data: "productID=" + productID + "&quantity=" + quantity + "&combination=" + combination + "&vat=" + vat,
                        async: false,
                        success: function (response) {
                            //console.log(response);
                            var price = parseFloat(response);
                            var include_vat = parseInt($('#include_vat').val());
                            if(include_vat) price = roundDecimal(price);
                            var list_price = parseFloat($('#list_price').attr('data-list_price'));
                            var earning = list_price - price;
                            var save_percent = parseInt((100 - (100 * (price / list_price))));
                            $('#qv_price').html(formatPrice(price, odyshop.currency)).attr('data-price', price);
                            $('#save_price').html(formatPrice(earning, odyshop.currency)).attr('data-save_price', earning);
                            $('#save_percent').text(save_percent);

                            if (!include_vat) {
                                $('#qv_final_price').html("(" + formatPrice(includeVat(price, vat), odyshop.currency) + " " + t("με ΦΠΑ") + ")");
                            }
                        }
                    });
                }
            </script>
            <?php
        }
        break;

}

$this->javascript = ob_get_clean();

// seo settings
$seoNotFound = true;
if ($id) {
    $seoQuery = "select * from `seo` where sectionID='$this->sectionID' and itemId='$id' and langID='$langID'";
    $seo = $db->getRecord($seoQuery);
    if (!$seo) {
        $seoNotFound = true;
    } else {
        $seoNotFound = (empty($seo->title) && empty($seo->description) && empty($seo->keywords) && empty($seo->meta));
    }
    if (!$seoNotFound) { // specific seo settings found
        if ($seo->title) $this->setHtmlTitle(strip_tags($seo->title), !$seo->overwrite_title); // in case of true in second argument, the append behavior will be activated
        $meta = array(
            '<meta name="description" content="' . $seo->description . '">',
            '<meta name="keywords" content="' . $seo->keywords . '">'
        );
        $meta_entries = explode(PHP_EOL, $seo->meta);
        $meta = array_merge($meta, $meta_entries);
        $this->setMeta($meta);
    }
}
if ($seoNotFound) { // general settings
    $words = "";
// add a description for this section
    if ($catID) {
        $catPath = $categories->getPath($catID, $section . '_categories');
        $breadcrumb = array();
        foreach ($catPath as $node) {
            $breadcrumb[] = $categories->getCategoryName($node, "content_" . $section . "_categories", $langID);
        }
        $keywords = implode(", ", $breadcrumb);
        $separator = $this->appendMark;
        $breadcrumb = implode($separator, $breadcrumb);
        if ($breadcrumb) $breadcrumb .= $separator;
        $sectionDescription = $breadcrumb . $categories->getCategoryName($catID, "content_" . $section . "_categories", $langID);
        $keywords .= ", " . $categories->getCategoryName($catID, "content_" . $section . "_categories", $langID);
    }
    if ($breadcrumb) $words .= $keywords . ", ";
    if ($id) $sectionDescription = $item->title;
// add general meta tags
    $words .= t($parameters->getParameter('keywords'));
    $meta = array(
        '<meta name="description" content="' . $sectionDescription . '">',
        '<meta name="keywords" content="' . $words . '">'
    );
    $theTitle = ($thisView == "search") ? t("Αναζήτηση") : $sectionDescription;
    $this->setHtmlTitle(strip_tags($theTitle), true); // true to activate the append behavior
    $this->setMeta($meta);
}


// add js and css files for this section
$this->setStyles($cssFiles);
$this->setJsFiles($sectionJsFile);
$this->setJsFiles($jsFiles);
$this->setJsReady(is_file($sectionJsReadyFile) ? file_get_contents($sectionJsReadyFile) . $this->javascript_ready : $this->javascript_ready);

if ($doNotPassData) {
    unset($items, $numOfAllItems, $maxrows);
}

$hasSubcategories = false; // legacy for old templates

$controllerVars = array('controllerVars', 'keyword', 'items', 'item', 'numOfAllItems', 'maxrows', 'page', 'presults', 'doNotPassData', 'searchForCategories', 'searchForNumbers', 'searchForDates', 'searchForFlags', 'searchForSections', 'countyID', 'hasSubcategories', 'subCategories', 'multi_categories', 'breadcrumb', 'IDs', 'min_price', 'max_price'); // standard controller variables  passing to the view
foreach ($safeRequest as $key => $value) { // check if there are specific variables that must pass to the view
    if (preg_match('/ID$/', $key)) $controllerVars[] = $key; // any ID vars
    if (preg_match('/_from$/i', $key) || preg_match('/_to$/', $key)) $controllerVars[] = $key; // any limits vars
    if (preg_match('/submit/i', $key)) $controllerVars[] = $key;     // any submits vars
    if (in_array($key, array_keys($statuses))) $controllerVars[] = $key; // vars that been set as search criteria
}
$controllerVars = array_unique($controllerVars);
// pass the selected vars to the current view
foreach ($controllerVars as $var) {
    $this->$var = ${$var};
    $this->setData($this->$var);
}
?>