<?php
if (preg_match('/\/index\.php\//', $_SERVER['REQUEST_URI'])) {
    echo "Invalid URI";
    exit;
}
if (preg_match('/mediabank\/medium\/mediabank/', $_SERVER['REQUEST_URI'])) {
    echo "Invalid URI";
    exit;
}
define("CMS", "korCMS");
require_once("config/odyssey.ini.php");    // access from root folder
require_once("functions.php");
setErrorReporting();
include("library/db.php");
include("library/system.php");
include("library/messages.php");
include("library/sef.php");
include("library/variables.php");
include("library/language.php");
include("library/parameters.php");
include("library/content.php");
include("library/document.php");
$db = new db();
$system = new system();
$messages = new messages();
$sef = new sef();
$variables = new variables();
$language = new language();
$parameters = new parameters();
$content = new content();
$document = new document('', '', true);
$protocol = getProtocol();
$force_ssl = $parameters->getParameter("ssl"); // if force SSL URL is enabled or not
if ($force_ssl && $protocol != 'https') { // then force URL to use https
    setSSL();
}
if ($_SERVER['SERVER_NAME'] != "localhost") {
    if ($_GET['PHPSESSID']) session_id($_GET['PHPSESSID']);
}
session_start();
unset($_SESSION['odyssey_errors'], $_SESSION['odyssey_messages'], $_SESSION['custom_script_name']);

// check if we have $_REQUEST variables that must be stores in SESSION. These vars must have a prefix [ session_ ]
foreach ($_REQUEST as $key => $value) {
    if ($key != "session_data" && !is_array($_REQUEST[$key]) && preg_match('/^session\_/', $key)) {
        $_SESSION[$key] = $_REQUEST[$key];
    }
}

if (!function_exists("get_data")) {
    function get_data($url) {
        $ch = curl_init();
        $timeout = 1;
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_POST, 1);
        $data = curl_exec($ch);
        curl_close($ch);
        return $data;
    }
}

if ($_SERVER['SERVER_NAME'] != "localhost") {
    $latestVersion = get_data("http://odyssey.webpage.gr/new/updates.php?url=" . $domain_name);
    if ($latestVersion == "invalid") {
        ?>
        <script type="text/javascript">
            document.location.href = "http://odyssey.webpage.gr";
        </script>
        <?php
        exit;
    }
}

if (preg_match('/fb_comment_id/', $_SERVER['REQUEST_URI'])) {
    $redirectURL = explode("fb_comment_id", $_SERVER['REQUEST_URI']);
    $redirectURL = $redirectURL[0];
    header("location:" . $redirectURL);
    exit;
}
$temp = explode("?", $_SERVER['REQUEST_URI']);
$parts = explode('/', $temp[0]);
array_shift($parts); // the first element will be empty to we get rid of it
if (end($parts) == '') array_pop($parts); // last element is empty cause has directory slash and must be removed
$custom_script_name = end($parts);
$use_custom_script = is_file($document->getTemplatePath() . $custom_script_name . ".php");
if (!$parameters->getParameter("sef") && !$use_custom_script) die("Bad Request");
$qs = $temp[1];
$queryArray = $variables->parseQuery($qs);
$languageDefined = false;
foreach ($queryArray as $key => $value) {
    if ($key == "langID") {
        $langID = (int)$value;
        if ($language->isLanguageActive($langID)) {
            $languageDefined = true;
            break;
        }
    }
    if ($key == "logout" && $value = "1") {
        $userID = $_SESSION['userID'];
        $q = "delete from connected_users where userID = '$userID'";
        $db->query($q);
        $_SESSION['userUsername'] = NULL;
        $_SESSION['userPassword'] = NULL;
        $_SESSION['userID'] = NULL;
        $_SESSION['loginLevel'] = 0;
        $_SESSION['checkout'] = array();
    }
}

$path_parts = explode("/", $_SERVER["PHP_SELF"]);
array_shift($path_parts); // the first element will be empty to we get rid of it
array_pop($path_parts); // get rid of script name
$index = count($path_parts);
$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https" : "http";
$path = $protocol . "://" . $_SERVER['HTTP_HOST'] . "/" . implode("/", $path_parts) . "/";
$languageExtension = $parts[$index];

if (!empty($languageExtension) && !$languageDefined) {
    $langID = $language->getLanguageByExtension("_" . $languageExtension);
    $langID = ($language->isLanguageActive($langID)) ? $langID : $language->getDefaultLanguage();
    $langID = ($languageExtension == "gr") ? 1 : $langID;
    if ((int)$langID) $languageDefined = true;
}
$section = $parts[$index + 1];
$view = $parts[$index + 2];
if (!$use_custom_script) {
    $parameter = $parts[$index + 3];
    if ($section == "pages") {
        $view = "render";
        $parameter = "page";
        $page = $parts[$index + 2];
    }
    $section = (!empty($section)) ? $section : "odyssey_index";
    $view = (!empty($view)) ? $view : "odyssey_index";
    $script = "index.php";
    $sectionID = $system->getTableSectionID($section);
}

$langID = ($languageDefined) ? (int)$langID : $_SESSION['currentLanguage'];
$qs = ($qs) ? $qs . "&langID=" . $langID : "langID=" . $langID;
if ($language->isLanguageActive($langID)) $language->setCurrentLanguage($langID);


if (!$use_custom_script) {
    switch ($parameter) {

        case "categories":
            $numOfParts = count($parts);
            for ($idx = $numOfParts - 1; $idx >= 0; $idx--) {
                $alias = $sef->getActualAlias($parts[$idx]);
                if ($alias) {
                    $tableName = $sef->isCategoryAliasExists();
                    if ($tableName) {
                        $q = "select aliases.itemID as id from aliases, " . $section . "_categories where aliases.alias='$alias' and aliases.itemID=" . $section . "_categories.id and aliases.sectionID=" . $sectionID . " and aliases.isCategory=1";
                        $catID = $db->getRecord($q)->id;
                        $contents = $path . $script . "?section=" . $section . "&view=" . $view . "&catID=" . $catID . "&" . $qs;
                        break;
                    }
                }
            }
            break;

        case "archive":
            $month = $parts[$index + 4];
            $year = $parts[$index + 5];
            if (!(int)$month || !(int)$year) break;
            $contents = $path . $script . "?section=" . $section . "&view=" . $view . "&month=" . $month . "&year=" . $year . "&" . $qs;
            break;

        case "page":
            $alias = $sef->getActualAlias($page);
            $id = $db->getRecord("select aliases.itemID as id from aliases, $section where aliases.alias='$alias' and aliases.itemID=$section.id and aliases.sectionID=" . $sectionID . " and $section.active=1")->id;
            if (!(int)$id) break;
            $contents = $path . $script . "?section=" . $section . "&view=" . $view . "&id=" . $id . "&" . $qs;
            break;


        default:

            $alias = $parameter;
            $alias = $sef->getActualAlias($parameter);
            if ($system->isTableSectionExists(null, $section, null)) {
                $id = $db->getRecord("select aliases.itemID as id from aliases, $section where aliases.alias='$alias' and aliases.itemID=$section.id and aliases.sectionID=" . $sectionID . " and $section.active=1")->id;
            }
            if (!(int)$id) break;
            if ($system->getSectionProperty($section, "hasCategory") && $id) { // only for items that belong to categories
                $catID = $db->getRecord("select catID from " . $section . " where id='" . $id . "'")->catID;
            }

            $contents = $path . $script . "?section=" . $section . "&view=" . $view . "&id=" . $id . "&catID=" . $catID . "&" . $qs;
    }
} else {
    // check if we have post and files from custom script
    unset($_SESSION['_post'], $_SESSION['_get'], $_SESSION['_files'], $_SESSION['_cookie']); // initialize
    if (count($_POST)) $_SESSION['_post'] = $_POST;
    if (count($_GET)) $_SESSION['_get'] = $_GET;
    if (count($_FILES)) $_SESSION['_files'] = $_FILES;
    if (count($_COOKIE)) $_SESSION['_cookie'] = $_COOKIE;
    if ($section == "pages" && $view == "dynamic") {
        $contents = $path . "index.php?section=" . $section . "&page=" . $custom_script_name . "&view=" . $view . "&" . $qs;
    } else {
        $_SESSION['custom_script_name'] = $custom_script_name;
        $contents = $path . "index.php?custom_script=" . $custom_script_name . "&" . $qs;
    }
}

if (!function_exists("array_htmlentities")) {
    function array_htmlentities(&$elem, $mode = "encode") {
        global $variables;
        if (!is_array($elem)) {
            if ($mode == "encode") {
                if ($variables->isMultiByte($elem)) {
                    $elem = "__" . base64_encode($elem);
                }
                $elem = htmlspecialchars($elem);
            } else {
                if (preg_match('/^__/', $elem)) {
                    $elem = base64_decode(substr($elem, 2));
                }
                $elem = html_entity_decode($elem);
            }
        } else {
            foreach ($elem as $key => $value) $elem[$key] = array_htmlentities($value, $mode);
        }
        return $elem;
    }
}

// -------------------------------------------
if ($view == "en" || $view == "gr") { // mysterious error handling
    echo "A system error has occurred. Please try again later";
    exit();
}
// -------------------------------------------

$ip = $_SERVER["REMOTE_ADDR"];
$_SESSION['ip'] = $ip;
$_SESSION['sessionID'] = (!isset($_SESSION['sessionID'])) ? session_id() : $_SESSION['sessionID'];
$_SESSION['odykey'] = $adminPass;
$thisSession = md5(rand());
$filename = "uploads/" . $thisSession;
$file = fopen($filename, "w+");
flock($file, 2);
fputs($file, serialize($_SESSION));
flock($file, 3);
fclose($file);
$sessionString = "&session_data=" . $thisSession;
if ($protocol == "https") $sessionString .= "&secure_protocol=1";

if (!empty($contents)) {
    header('HTTP/1.1: 200 OK');
    readfile($contents . $sessionString);
} else {
    @include("router.php");
    if (is_file($script) && !$parameter) {
        $contents = $path . $script . "?section=" . $section . "&view=" . $view . "&" . $qs . $sessionString;
        header('HTTP/1.1: 200 OK');
        readfile($contents);
    } else {
        header('location:' . rtrim($path, "/") . '/404.php');
    }
}
?>