
(function($){
	$.fn.extend({
		jOthumb: function(options) {
			var defaults = {
				speed:150,
				outSpeed:600, 
				x:null, 
				y:null,
				static: 0
			}
			var options =  $.extend(defaults, options);
			return this.each(function() {
                var obj = $(this);
                options.x = obj.data('x') || options.x;
                options.y = obj.data('y') || options.y;
                options.speed = obj.data('speed') || options.speed;
                options.outSpeed = obj.data('outSpeed') || options.outSpeed;
                var o = options;
				var containerWidth = obj.width();
				var containerHeight = obj.height();
				var contents = $('[data-descr="contents"]', obj);
				var width = contents.width();
				var height = contents.height();
				if(containerWidth > width){ 
					obj.css("width", width); 
					containerWidth = width;
				}
				if(containerHeight > height){ 
					obj.css("height", height);
					containerHeight = height;
				}
				o.x = Math.abs(o.x) ? -o.x : o.x;
				o.y = Math.abs(o.y) ? -o.y : o.y;
				var initTop = (o.y != null) ? o.y : -((height-containerHeight)/2);
				var initLeft = (o.x != null) ? o.x : -((width-containerWidth)/2);
				obj.css({ "position": "relative", "overflow": "hidden" });
				removeStyles(false);
				contents.css({ "position": "absolute", "top": initTop, "left": initLeft});	
				obj.wrap(function() {
 					return '<div style="height: ' + containerHeight + 'px" />';
				});
				setTimeout(function(){obj.css({ "visibility": "visible" });}, 500);	
				if(!Modernizr.touch){	// mouse over only for non-touch devices								
					$(this).mouseover(function(e){
						doAnimation(initLeft, initTop);
					});
					$(this).mouseleave(function(e){
						if(o.static || $(window).width() < 480) return false; // prevent animation for statics or small screens
						contents.stop().animate({top: initTop, left: initLeft}, o.outSpeed);
						obj.stop().animate({top: 0, left: 0, width: containerWidth, height: containerHeight}, o.outSpeed, function(){
							removeStyles(true);
						});
					});
				}
				function doAnimation(initLeft, initTop){
					if(o.static || $(window).width() < 480) return false; // prevent animation for statics or small screens
					setStyles();
					contents.stop().animate({top: 0, left: 0}, o.speed);
					obj.stop().animate({top: -(height-containerHeight)/2, left: -(width-containerWidth)/2, width: width, height: height}, o.speed);
					
				}
				function setStyles(){
					window.zIndex++;
                    obj.parent().parent().css('border', '1px solid transparent');
					obj.css({
						"border": "4px solid white", 
						"-moz-box-shadow": "2px 2px 10px rgba(0,0,0,0.8)", 
						"-webkit-box-shadow": "2px 2px 10px rgba(0,0,0,0.8)", 
						"box-shadow": "2px 2px 10px rgba(0,0,0,0.6)", 
						"filter": "progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=130, Color='#3b3b3b')", 
						"-ms-filter": "progid:DXImageTransform.Microsoft.Shadow(Strength=4, Direction=130, Color='#3b3b3b')", 
						"zoom": "1" ,
						"z-index": window.zIndex 
						});					
				}
				function removeStyles(restoreBorder){
					window.zIndex = 1;
                    if(restoreBorder) obj.parent().parent().css('border', '1px solid #d8d8d8');
					obj.css({
						"border": "4px solid transparent",
						"-moz-box-shadow": "2px 2px 10px rgba(0,0,0,0)", 
						"-webkit-box-shadow": "2px 2px 10px rgba(0,0,0,0)", 
						"box-shadow": "2px 2px 10px rgba(0,0,0,0)", 
						"filter": "", 
						"-ms-filter": "",
						"z-index":window. zIndex 
					});
				}				
			});
		}
	});

})(jQuery);


