<?php 
defined('CMS') or die("This file cannot run this way!");
class categories{
	
	function hasAccess($catID){ // only for Odyshop products categories
		global $auth;
		if($auth->getAdminLevel() != -100) return true; // admin has always access
		global $db;
		$userLevel = $auth->getLoginStatus();
		$q="select account_type from cat_access where catID='$catID'";
		$account_types_results = $db->getRecords($q);
		$account_types = array();
		foreach($account_types_results as $at){
			$account_types[] = (int)$at->account_type;
		}
		if(in_array($userLevel, $account_types)) return true;
		return false;
	}
	
	function getParent($node, $source='menu_options_categories'){
		if(!$node) return 0;
		$parent = $this->getPath($node, $source);
		$parent = $parent[sizeof($parent)-1];
		return $parent;
	}
	
	
	function isParent($node, $source='menu_options_categories'){
		global $db;
		return ($db->getNumRows("SELECT id from `$source` WHERE parent='$node' LIMIT 1")) ? true : false;
	}
	
	
	function getPath($node, $source='menu_options_categories') {
		global $db;
		$row = $db->getRecord("SELECT parent from `$source` WHERE id='$node'");
		$path = array();
		if ($row->parent!=0) {
			$path[] = $row->parent;
			$path = array_merge($this->getPath($row->parent, $source), $path);
		}
		return $path;
	} 

	function getParentName($node, $source='menu_options_categories'){
		global $language;
		global $langID;
		$parent = $this->getParent($node, $source);
		global $db;
		$row = $db->getRecord("SELECT title  FROM content_$source WHERE catID='$parent' and langID='$langID'");
		return ($row->title) ? $row->title : false ;
	}


	function getCategoriesForSelect($parent=0, $level=0, $showRoot=true, $section="menu_options_categories", $selectedCatID, $showGroup=true, $optgroup = array(), $hasContent = false) {
		$MPTT = $this->isPreorderTreeTraversal($section);
		$content_table = "content_".$section;
		global $language;
		global $langID;
		global $db;
		if($selectedCatID){
			$Prow = $db->getRecord("SELECT parent from `$section` WHERE id='$selectedCatID'");
			$thisParent = $Prow->parent;
		}
		if($showRoot){
			$selected = ($Prow->parent==0)? " selected='selected' " : "";
			echo("<option value=0 ".$selected." style='padding-right:20px'>root ".t("(κύρια κατηγορία)")."</option>".PHP_EOL);
		}
		$q = "SELECT $section.id as id, $content_table.title as title, $content_table.link as link  
							from `$section`, $content_table 
							WHERE $section.parent='$parent' and $section.id=$content_table.catID and $content_table.langID='$langID' 
							ORDER BY $section.sort, $content_table.title";
		$records = ($MPTT) ? $this->getTreePTT($section, "order by title", $parent) : $db->getRecords($q);
		foreach($records as $row){
			if($section == "products_categories"){
				if(!$this->hasAccess($row->id)) continue; // skip category
			}
			$level = ($MPTT) ? $row->level : $level;
			if($this->isParent($row->id, $section)){
				if($showGroup){
					if(count($optgroup) && $optgroup[count($optgroup)-1] < $level) {
						if(empty($hasContent)) echo "<option class='select2-search-hidden'></option>";
						echo "</optgroup>".PHP_EOL;
						array_pop($optgroup);
					}
					$optgroup[] = $level;
					if($hasContent) echo "</optgroup>".PHP_EOL;		
					$hasContent = false;							
					echo("<optgroup data-catid='".$row->id."' label='".str_repeat('&nbsp;',($level/2)*6).$row->title."'>".PHP_EOL);
				}else{
					$selected = ($selectedCatID == $row->id)? " selected='selected'" : "";
					$attr = " data-link='".$row->link."' data-parent-id='".$row->id."' data-level='".$level."'";
					echo("<option".$attr." value='".$row->id."' ".$selected."  style='padding-right:20px'>".str_repeat('&nbsp;',($level/2)*6).$row->title."</option>".PHP_EOL);
				}
			}else{
				$hasContent = true;
				$selected = ($selectedCatID == $row->id)? " selected='selected'" : "";
				$attr = " data-leaf='1' data-link='".$row->link."' data-parent='".$row->parent."' data-level='".$level."'";
				if(count($optgroup) && ($optgroup[count($optgroup)-1] > $level) || (count($optgroup) && empty($level))) {
					echo "</optgroup>".PHP_EOL;
					array_pop($optgroup);
				}				
				echo("<option".$attr." value='".$row->id."' ".$selected."  style='padding-right:20px'>".str_repeat('&nbsp;',($level/2)*6).$row->title."</option>".PHP_EOL);
			}
			if(!$MPTT) $this->getCategoriesForSelect($row->id, $level+1, false, $section, $selectedCatID, $showGroup, $optgroup, $hasContent);
		}
		if(count($optgroup) && $optgroup[count($optgroup)-1] > $level) {
			echo "</optgroup>".PHP_EOL;
		}		
	}
	
	
	function getArrayOfCategoriesForSelect($parent=0, $level=0, $showRoot=true, $section="menu_options_categories", $selectedCatID, $showGroup=true, $optgroup = array(), $hasContent = false) {
		$MPTT = $this->isPreorderTreeTraversal($section);
		$content_table = "content_".$section;
		global $language;
		global $langID;
		global $db;
		global $opts;
		if(!$level) $opts = "";
		if($selectedCatID){
			$Prow = $db->getRecord("SELECT parent from `$section` WHERE id='$selectedCatID'");
			$thisParent = $Prow->parent;
		}
		if($showRoot){
			$selected = ($Prow->parent==0)? " selected='selected' " : "";
			$opts.= "<option value=0 ".$selected." style='padding-right:20px'>root ".t("(κύρια κατηγορία)")."</option>".PHP_EOL;
		}
		$q = "SELECT $section.id as id, $content_table.title as title 
							from `$section`, $content_table 
							WHERE $section.parent='$parent' and $section.id=$content_table.catID and $content_table.langID='$langID' 
							ORDER BY $content_table.title";
		$records = ($MPTT) ? $this->getTreePTT($section, "order by title", $parent) : $db->getRecords($q);
		foreach($records as $row) {
			if($section == "products_categories"){
				if(!$this->hasAccess($row->id)) continue; // skip category
			}			
			$level = ($MPTT) ? $row->level : $level;
			if($this->isParent($row->id, $section)){
				if($showGroup){
					if(count($optgroup) && $optgroup[count($optgroup)-1] < $level) {
						if(empty($hasContent)) $opts.= "<option class='select2-search-hidden'></option>";
						$opts.= "</optgroup>".PHP_EOL;
						array_pop($optgroup);
					}	
					$optgroup[] = $level;
					if($hasContent) $opts.= "</optgroup>".PHP_EOL;		
					$hasContent = false;									
					$opts.= "<optgroup data-catid='".$row->id."' label='".str_repeat('&nbsp;',($level/2)*6).$row->title."'><option class='select2-search-hidden'></option></optgroup>".PHP_EOL;
				}else{
					$selected = ($selectedCatID == $row->id)? " selected='selected'" : "";
					$opts.= "<option value='".$row->id."' ".$selected."  style='padding-right:20px'>".str_repeat('&nbsp;',($level/2)*6).$row->title."</option>".PHP_EOL;
				}
			}else{
				$hasContent = true;
				$selected = ($selectedCatID == $row->id)? " selected='selected'" : "";
				$attr = " data-parent='".$row->parent."' data-level='".$level."'";
				if(count($optgroup) && ($optgroup[count($optgroup)-1] > $level) || (count($optgroup) && empty($level))) {
					$opts.= "</optgroup>".PHP_EOL;
					array_pop($optgroup);
				}				
				$opts.= "<option".$attr." value='".$row->id."' ".$selected."  style='padding-right:20px'>".str_repeat('&nbsp;',($level/2)*6).$row->title."</option>".PHP_EOL;
			}
			if(!$MPTT) if(!$MPTT) $this->getArrayOfCategoriesForSelect($row->id, $level+1, false, $section, $selectedCatID, $showGroup, $optgroup, $hasContent);
		}
		if(count($optgroup) && $optgroup[count($optgroup)-1] > $level) {
			$opts.= "</optgroup>".PHP_EOL;
		}		
		return $opts;
	}	
		
	
	function getFirstCategoryID($sectionName){
		global $db;
		$q = "select id from ".$sectionName."_categories order by sort limit 1";
		$row = $db->getRecord($q);
		return ($row->id)? $row->id : false;
	}		
	
	function getActiveMultiCategoriesForSelect($parent=0, $level=0, $tableSection, $selectedCatID, $showGroup=true){
		// ισχύει για multi categories in selectlists mysql table
		$content_table = "content_".$tableSection;
		$padd=2; //padding for levels
		global $language;
		global $langID;
		global $db;
		if($selectedCatID){
			$Prow = $db->getRecord("SELECT parent from `$tableSection` WHERE id='$selectedCatID'");
			$thisParent = $Prow->parent;
		}
		global $system;
		$tableSectionID = $system->getTableSectionID(str_replace("_categories", null, $tableSection));
		$fieldID = $system->getFieldID("catID", $tableSectionID);
		$q = "SELECT distinct ".$tableSection.".id as id, 
		".$tableSection.".parent as parent,
		content_".$tableSection.".title as title,
		content_".$tableSection.".link as link ";
		$q.=", ".$tableSection.".target as target ";
		$q.=" FROM ".$tableSection.", content_".$tableSection.", selectlists  
		WHERE ".$tableSection.".id=selectlists.optionID 
		and ".$tableSection.".id=content_".$tableSection.".catID 
		and selectlists.sectionID=".$tableSectionID."  
		and selectlists.fieldID=".$fieldID." 
		and content_".$tableSection.".langID='$langID' ";
		$q.=" order by ".$tableSection.".sort, content_".$tableSection.".title";
		$res = $db->query($q);
		$registeredIDs = array();
		while ($row = $db->getRecord($res)) {
			if($tableSection == "products_categories"){
				if(!$this->hasAccess($row->id)) continue; // skip category
			}			
			$roots = $this->getPath($row->id, $tableSection);

			foreach($roots as $id){
				$level = array_search($id, $roots);
				if(!in_array($id, $registeredIDs)){
					$q = "SELECT distinct ".$tableSection.".id as id, 
					".$tableSection.".parent as parent,
					content_".$tableSection.".title as title,
					content_".$tableSection.".link as link ";
					$q.=", ".$tableSection.".target as target ";
					$q.=" FROM ".$tableSection.", content_".$tableSection."   
					WHERE ".$tableSection.".id = $id  
					and ".$tableSection.".id=content_".$tableSection.".catID 
					and content_".$tableSection.".langID='$langID' ";
					$res2 = $db->query($q);
					$row2 = $db->getRecord($res2);
					if($tableSection == "products_categories"){
						if(!$this->hasAccess($row2->id)) continue; // skip category
					}					
					if($this->isParent($row2->id, $tableSection)){
						if($showGroup){
							echo("<OPTGROUP data-catid='".$row2->id."' disabled LABEL='".str_repeat('&nbsp;',$level*$padd).$row2->title."'></OPTGROUP>".PHP_EOL);
						}else{
							$selected = ($selectedCatID == $row2->id)? " selected='selected'" : "";
							echo("<option value='".$row2->id."' ".$selected." >".str_repeat('&nbsp;',($level+1)*$padd).$row2->title."</option>".PHP_EOL);
						}
					}else{
						$selected = ($selectedCatID == $row2->id)? " selected='selected'" : "";
						echo("<option value='".$row2->id."' ".$selected." >".str_repeat('&nbsp;',($level+1)*$padd).$row2->title."</option>".PHP_EOL);
					}					
				}
				$registeredIDs[] = $id;	
			}
			if($this->isParent($row->id, $tableSection)){
				$level=0;											

				if($showGroup){
					echo("<OPTGROUP data-catid='".$row->id."' disabled LABEL='".str_repeat('&nbsp;',$level*$padd).$row->title."'></OPTGROUP>".PHP_EOL);
				}else{
					$selected = ($selectedCatID == $row->id)? " selected='selected'" : "";
					echo("<option value='".$row->id."' ".$selected." >".str_repeat('&nbsp;',($level+1)*$padd).$row->title."</option>".PHP_EOL);
				}
			}else{
				$selected = ($selectedCatID == $row->id)? " selected='selected'" : "";
				echo("<option value='".$row->id."' ".$selected." >".str_repeat('&nbsp;',($level+1)*$padd).$row->title."</option>".PHP_EOL);
			}
		}		
	}
	
	
	
	function getCategoriesForSelectList($parent=0, $level=0, $section="menu_options_categories", $selectedOptions, $showGroup=true, $display=true, $optgroup = array(), $hasContent = false) {
		$MPTT = $this->isPreorderTreeTraversal($section);
		$selectedOptions = (!is_array($selectedOptions)) ? array() : $selectedOptions;
		$content_table = "content_".$section;
		global $language;
		global $langID;
		global $db;
		global $optionsHTML;
		if(!$display){
			if(!is_array($optionsHTML)) $optionsHTML = array();
		}
		$q = "SELECT $section.id as id, $content_table.title as title 
							from `$section`, $content_table 
							WHERE $section.parent='$parent' and $section.id=$content_table.catID and $content_table.langID='$langID' 
							ORDER BY $section.sort, $content_table.title";
		$records = ($MPTT) ? $this->getTreePTT($section, "order by title", $parent) : $db->getRecords($q);
		foreach($records as $row){
			if($section == "products_categories"){
				if(!$this->hasAccess($row->id)) continue; // skip category
			}			
			$level = ($MPTT) ? $row->level : $level;
			$contents = NULL;
			if($this->isParent($row->id, $section)){
				if($showGroup){
					if(count($optgroup) && $optgroup[count($optgroup)-1] < $level) {
						if(empty($hasContent)) $contents .= "<option class='select2-search-hidden'></option>";
						$contents .= "</optgroup>".PHP_EOL;
						array_pop($optgroup);
					}
					$optgroup[] = $level;
					if($hasContent) $contents .= "</optgroup>".PHP_EOL;		
					$hasContent = false;					
					$contents .= "<optgroup data-catid='".$row->id."' label='".$row->title."'>".PHP_EOL;
					if(!$display) $optionsHTML[] = $contents;
					if($display)	echo($contents);
				}else{
					$selected = null;
					foreach($selectedOptions as $selectedOption){
						if($row->id == $selectedOption->optionID) $selected = " selected='selected'";
					}
					$contents.= "<option value='".$row->id."' ".$selected.">".$row->title."</option>".PHP_EOL;
					if(!$display) $optionsHTML[] = $contents;
					if($display)	echo($contents);					
				}
			}else{
				$hasContent = true;				
				$selected = null;
				foreach($selectedOptions as $selectedOption){
					if($row->id == $selectedOption->optionID) $selected = " selected='selected'";
				}
				$attr = " data-parent='".$row->parent."' data-level='".$level."'";	
				if(count($optgroup) && ($optgroup[count($optgroup)-1] > $level) || (count($optgroup) && empty($level))) {
					$contents.= "</optgroup>".PHP_EOL;
					array_pop($optgroup);
				}							
				$contents.= "<option value='".$row->id."' ".$selected.">".$row->title."</option>".PHP_EOL;
				if(!$display) $optionsHTML[] = $contents;
				if($display)	echo($contents);					
			}
			if(!$MPTT) $this->getCategoriesForSelectList($row->id, $level+1, $section, $selectedOptions, $showGroup, $display, $optgroup, $hasContent);
		}
		if(count($optgroup) && $optgroup[count($optgroup)-1] > $level) {
			$optionsHTML[] = "</optgroup>".PHP_EOL;
		}		
		if(!$display) return $optionsHTML;
	}
	
	
	function getActiveCategoriesIDs($catSection, $onlyLeafs = false){
		global $language;
		$langID = $language->getCurrentLanguage();
		global $db;
		global $system;
		$activeIDs = array();		
		$tableSectionID = $system->getTableSectionID(str_replace("_categories", NULL, $catSection));
		$cftQuery = "select fieldType from `fields` where tableSectionID='$tableSectionID' and fieldVarName='catID'";
		$multiCategories = $db->getRecord($cftQuery)->fieldType == "selectList";
		if($multiCategories){
			$fieldID = $system->getFieldID("catID", $tableSectionID);
			$q = "SELECT distinct ".$catSection.".id as id 
			FROM ".$catSection.", content_".$catSection.", selectlists  
			WHERE ".$catSection.".id=selectlists.optionID 
			and ".$catSection.".id=content_".$catSection.".catID 
			and selectlists.sectionID=".$tableSectionID."  
			and selectlists.fieldID=".$fieldID." 
			and content_".$catSection.".langID='$langID' ";
			$res = $db->query($q);
			while ($row = $db->getRecord($res)){
				if($catSection == "products_categories"){
					if(!$this->hasAccess($row->id)) continue; // skip category
				}
                if(!$onlyLeafs) {
                    $roots = $this->getPath($row->id, $catSection);
                    foreach($roots as $id)	$activeIDs[] = $id;
                }
				$activeIDs[] = $row->id;
			}			
		}else{
			$tableSection = str_replace("_categories", NULL, $catSection);
			$q = "SELECT distinct ".$catSection.".id as id 
			FROM ".$tableSection.", ".$catSection.", content_".$catSection.", content_".$tableSection." 
			WHERE ".$catSection.".id=content_".$catSection.".catID 
			and ".$tableSection.".catID = ".$catSection.".id 
			and ".$tableSection.".id = content_".$tableSection.".mainID  
			and content_".$tableSection.".langID='$langID' 
			and content_".$catSection.".langID='$langID' ";	
			$cats = $db->getRecords($q);	
			foreach($cats as $cat){
				if($catSection == "products_categories"){
					if(!$this->hasAccess($cat->id)) continue; // skip category
				}				
				$activeIDs[] = $cat->id;
			}
		}
		$activeIDs = array_unique($activeIDs);
		return $activeIDs;
	}
	
	function isTheOnlyRoot($node, $table="menu_options_categories"){
		global $db;
		if(!$this->isRoot($node, $table)){
			return false;
		}else{
			return ($db->getNumRows("SELECT id from `$table` WHERE parent='0'") == 1) ? true : false;
		}
	}
	
	
	function isRoot($node, $table="menu_options_categories"){
		global $db;
		return ($db->getNumRows("SELECT id from `$table` WHERE id='$node' and parent='0'") > 0);
	}
	
	
	function getRoot($node, $table="menu_options_categories"){
		$nodepath = $this->getPath($node, $table);
		$noderoot = (!$nodepath[0]) ? 0 : $nodepath[0];
		return $noderoot;
	}
	
	
	function getCategoryName($catID, $content_table="content_menu_options_categories", $langID=null){
		if(!preg_match('/^content_/', $content_table)) $content_table = "content_".$content_table;
		global $language;
		$langID = ($langID != null) ? $langID : $language->getCurrentLanguage();
		global $db;
		$q = "SELECT title FROM $content_table WHERE catID='$catID' and langID='$langID'";
		$catrow = $db->getRecord($q);
		return $catrow->title;
	}	
	
	function getMultiCategories($section, $itemID){
		global $db;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name
		$sectionID = $section;
		$fieldID = $system->getFieldID("catID", $sectionID);
		$arr = array();
		$q="select distinct optionID from selectlists where sectionID='$sectionID' and fieldID='$fieldID' and itemID='$itemID' order by optionID";
		$rows = $db->getRecords($q);
		if(!count($rows)) return false; // no categories found
		foreach($rows as $row){
			if($section == "products_categories"){
				if(!$this->hasAccess($row->optionID)) continue; // skip category
			}			
			$arr[]=$row->optionID;
		}
		return $arr;
	}
    
	function displayMulticategories($itemID, $section){
		global $system;
		global $langID;
		$section = preg_replace('/_categories/', NULL, $section);		
		$sectionID = $system->getTableSectionID($section);
		if(empty($sectionID)){
			echo "Error: Invalid section";
			return;
		}
		$catIDs = $this->getMultiCategories($sectionID, $itemID);
		$cat_section= $section."_categories";
		$counter=0;
		foreach($catIDs as $cat){
			$counter++;
			$cat_path = $this->getPath($cat, $cat_section);
		?>
		<div class="branch<?php if($counter < count($catIDs)){echo "_multiple";}?>">
		<span class="cat_path_line">
		<?php
			foreach($cat_path as $node) echo $this->getCategoryName($node, "content_".$cat_section, $langID)." > ";
			echo $this->getCategoryName($cat, "content_".$cat_section, $langID);
			?>
		</span>
		</div>
		<?php
		}
	}	
	
	function getParentSection($categorySection){
		if(!preg_match('/_categories$/', $categorySection)) return false;
		return str_replace("_categories","", $categorySection);
	}

	function getParentSectionID($categorySection){
		if(!preg_match('/_categories$/', $categorySection)) return false;
		global $system;
		return $system->getTableSectionID($this->getParentSection($categorySection));
	}
	
	function getCategoryType($section, $fieldVarName="catID"){
		global $db;
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name
		$type = $db->getRecord("select fieldType from `fields` where fieldVarName='$fieldVarName' and tableSectionID='$section'")->fieldType;
		if($type != "selectMenu" && $type != "selectList") die("Invalid field type for category");
		return $type;
	}
	
	function getMenuCategory($section, $action){
		global $langID;
		global $db;
		$table="menu_options_categories";
		$criteria = "sections.php?section=".$section."&action=".$action;
		$q = "select $table.id, $table.access from $table, content_$table where $table.id=content_$table.catID and content_$table.link='$criteria' and content_$table.langID='$langID'";
		return $db->getRecord($q, false);
	}

    function getSubCategories($catID) {
        global $section;
        global $langID;
        global $db;
        $catQuery = "select distinct " . $section . "_categories.*, content_" . $section . "_categories.title, content_" . $section . "_categories.minitext 
							from " . $section . "_categories, content_" . $section . "_categories   
							WHERE " . $section . "_categories.parent='$catID' 
							and content_" . $section . "_categories.catID=" . $section . "_categories.id 
							and content_" . $section . "_categories.langID='$langID' 
							order by " . $section . "_categories.sort, content_" . $section . "_categories.title";
        $catItems = $db->getRecords($catQuery);
        return $catItems;
    }

    function getChildren($subCategoriesIDs) {
        $children = array();
        foreach ($subCategoriesIDs as $id) {
            $ids = $this->getCategoriesOfParent($id, array());
            foreach ($ids as $thisCatID) $children[] = $thisCatID;
        }
        return $children;
    }

    function getCategoriesOfParent($parent, $catIDs = array()) {
        $section = "products_categories";
        $MPTT = $this->isPreorderTreeTraversal($section);
        global $db;
        $q = "SELECT * from `$section` WHERE parent='$parent'";
        $records = ($MPTT) ? $this->getTreePTT($section, "order by title", $parent) : $db->getRecords($q);
        if (count($records)) {
            foreach ($records as $row) {
                if (!$this->hasAccess($row->id)) continue; // skip category
                $catIDs[] = $row->id;
                if (!$MPTT) $this->getCategoriesOfParent($row->id, $catIDs);
            }
        } else {
            $catIDs[] = $parent;
        }
        return $catIDs;
    }

	
	function isPreorderTreeTraversal($catTable){
		global $db;
		$q="select * from $catTable limit 1";
		$result = $db->query($q);
		return $db->getFieldName($result, 11) == "L";	
	}
	
	function rebuildTree($catTable, $parent=0, $left=1){
		if(!$this->isPreorderTreeTraversal($catTable)) return false;
		$right = $left+1;
		global $db;
		$items = $db->getRecords("select id from $catTable where parent='$parent' order by sort");
		foreach($items as $item){
			$right = $this->rebuildTree($catTable, $item->id, $right);
		}
		$db->query("UPDATE $catTable SET `L`='$left', `R`='$right' WHERE id='$parent'");
		return $right+1; 	
	}	

	function getTreePTT($catTable, $orderby="sort", $root=0) {
		global $db;
		global $langID;
		$nodes = array();
		$q = "SELECT $catTable.L, $catTable.R FROM $catTable, content_$catTable 
				WHERE $catTable.id = content_$catTable.catID 
				and content_$catTable.langID = '$langID' 
				and $catTable.parent='$root' order by ";
		if($orderby!="sort") $q.="content_$catTable.title, "; // title priority for sorting
		$q.="$catTable.sort";
		$items = $db->getRecords($q);
		foreach($items as $item){
			$right = array();
			$records = $db->getRecords("SELECT $catTable.*, content_$catTable.title, content_$catTable.link as link 
														FROM $catTable, content_$catTable 
														WHERE $catTable.`L` BETWEEN '$item->L' AND '$item->R' 
														and $catTable.id = content_$catTable.catID 
														and content_$catTable.langID = '$langID' 
														ORDER BY $catTable.`L` ASC");
			foreach($records as $record) {
				if (count($right) > 0) {
					while ($right[count($right)-1] < $record->R) {
						array_pop($right);
					}
				}
				$record->level = count($right);
				$nodes[] = $record;
				$right[] = $record->R;
			}
		}
		return $nodes;
	}
	
	function getCategoryImage($catID, $section){
		global $system;
		if(!is_numeric($section)) $section = $system->getTableSectionID($section); // not an id, try if its a name
		$tableSectionID = $section;	
		$categoryImage = NULL;
		$extensions = array("jpg", "jpeg", "png", "gif");
		foreach($extensions as $ext){
			$test = __DIR__.DIRECTORY_SEPARATOR."..".DIRECTORY_SEPARATOR."mediabank".DIRECTORY_SEPARATOR."cat".$tableSectionID."_".$catID.".".$ext;
			if(is_file($test)){
				$parts = explode(DIRECTORY_SEPARATOR, $test);
				$categoryImage = array_pop($parts);
				return $categoryImage;
			}
		}
		return NULL; // no image found			
	}
	
	
	
} // end class
?>