<?php

class articles extends view
{

    function getData($article) {
        if (!is_object($article)) return false;
        global $langID;
        global $document;
        global $parameters;
        global $content;
        global $variables;
        global $categories;
        global $dates;
        global $db;
        global $sef;
        if (!is_object($sef)) $sef = new sef();
        $section = $document->section;
        $sectionID = $document->sectionID;
        $data = new stdClass();
        $fieldsRows = $db->getRecords("select `fieldVarName` from `fields` where tableSectionID='$sectionID' and active=1");
        foreach ($fieldsRows as $field) {
            $data->{$field->fieldVarName} = $article->{$field->fieldVarName}; // auto import section fields as vars
        }
        $data->title = strip_tags($data->title);
        $data->id = $article->id;
        $data->catName = $categories->getCategoryName($data->catID, "content_" . $section . "_categories", $langID);
        $max_chars = $parameters->getParameter("max_chars");
        $data->minitext = $variables->getMinitext($data->minitext, $max_chars);
        if (!$data->minitext) $data->minitext = $variables->getMinitext($data->body, $max_chars); // make minitext from body if possible
        $defaultImage = $content->getDefaultImage($section, $data->id);
        $data->hasDefaultImage = false; // initializing as false
        if ($defaultImage) { // if a default image exists for this record
            $imageFile = "mediabank/images/" . $defaultImage;
            if (is_file($imageFile)) $data->hasDefaultImage = true;
        } else {
            $imageFile = "images/no_image.png";
        }
        $data->image = $imageFile;     // default image
        $data->mediumImage = ($data->hasDefaultImage) ? "mediabank/medium/medium_" . $defaultImage : $imageFile;
        $data->imgDescription = ($document->hasSubcategories) ? NULL : $content->getImageDescription($data->image, $data->id, $sectionID, $langID);
        $data->images = $content->getImages($section, $data->id, $langID, array('default', 'logo', 'slider'));
        if (!$data->images) $data->images = array();
        if ($defaultImage) array_unshift($data->images, $defaultImage); // prepend default image to the begining of the images array
        $data->crop_image = $content->getCropImage($data->mediumImage, $data->id, $sectionID);
        $data->link = ($document->hasSubcategories)
            ?
            $sef->url("index.php?section=" . $section . "&view=list&catID=" . $data->id, false)
            :
            $sef->url("index.php?section=" . $section . "&view=node&id=" . $data->id, false);
        if ($data->published) $data->published = $dates->makeDatefromTimestamp($data->published);
        $data->body = $content->richText($data->body);
        return $data;
    }

    function getCategoryData($category) {
        if (!is_object($category)) return false;
        global $document;
        global $parameters;
        global $variables;
        global $categories;
        global $sef;
        if (!is_object($sef)) $sef = new sef();
        $section = $document->section;
        $data = new stdClass();
        $data->id = $category->id;
        $data->title = $category->title;
        $max_chars = $parameters->getParameter('max_chars');
        $data->minitext = $variables->getMinitext($category->minitext, $max_chars);
        $data->image = "mediabank/" . $categories->getCategoryImage($data->id, $section);
        $data->link = $sef->url("index.php?section=" . $section . "&view=list&catID=" . $data->id, false);
        return $data;
    }

    function getListingTitle() {
        global $document;
        global $safeRequest;
        global $langID;
        $section = $document->section;
        $sectionID = $document->sectionID;
        $catID = $safeRequest->catID;
        if ($document->view != "search") {
            if ($catID) {
                global $categories;
                $title = $categories->getCategoryName($catID, "content_" . $section . "_categories", $langID);
            } else {
                global $system;
                $sectionName = t($system->getTableSectionTitle($sectionID));
                $title = (is_numeric($catID) && $catID == 0) ? $sectionName . " - " . t("ΚΑΤΗΓΟΡΙΕΣ") : $sectionName;
            }
            if ($document->tagExists) $title .= " (".t("για")." tag: " . $safeRequest->tag . ")";
        } else {
            $title = (empty($safeRequest->submitSearch)) ? t("Αναζήτηση") : t("Αποτελέσματα αναζήτησης");
        }
        return strip_tags($title);
    }

    function getSearchForm() {
        ob_start();
        global $document;
        global $safeRequest;
        global $langID;
        global $categories;
        global $dates;
        $section = $document->section;
        ?>
        <form action="index.php" method="get">
            <input name="langID" type="hidden" value="<?php echo $langID; ?>">
            <input type="hidden" name="section" value="<?php echo $section; ?>">
            <input type="hidden" name="view" value="search">
            <div class="formTable">
                <div style="margin: 0 auto;" class="form_container">
                    <div class="formLabel left"><?php echo t("Αναζήτηση για"); ?>:</div>
                    <div><input class="textbox" name="keyword" type="text" value="<?php echo $safeRequest->keyword; ?>"></div>
                </div>

                <div style="margin: 0 auto;" class="form_container">
                    <div class="formLabel left"><?php echo t("Στην κατηγορία"); ?>:</div>
                    <div>
                        <select name="catID" class="listbox">
                            <option value=""><?php echo t("Όλες οι κατηγορίες"); ?></option>
                            <?php echo $categories->getCategoriesForSelect(0, 0, false, $section . "_categories", $safeRequest->catID); ?>
                        </select>
                    </div>
                </div>

                <?php
                if ($safeRequest->published_from) $safeRequest->published_from = $dates->makeTimestamp($safeRequest->published_from);
                if ($safeRequest->published_to) $safeRequest->published_to = $dates->makeTimestamp($safeRequest->published_to);
                ?>

                <div style="margin: 0 auto;" class="form_container">
                    <div class="formLabel left"><?php echo t("Δημοσιευμένο από"); ?>:</div>
                    <input class="textbox date_picker" style="width:200px" name="published_from" id="published_from"
                           type="text"
                           value="<?php if ($safeRequest->published_from) echo $dates->makeDatefromTimestamp($safeRequest->published_from); ?>">
                </div>

                <div style="margin: 0 auto;" class="form_container">
                    <div class="formLabel left"><?php echo t("Δημοσιευμένο έως"); ?>:</div>
                    <input class="textbox date_picker" style="width:200px" name="published_to" id="published_to"
                           type="text"
                           value="<?php if ($safeRequest->published_to) echo $dates->makeDatefromTimestamp($safeRequest->published_to); ?>">
                </div>

                <div style="margin: 20px auto; display:table">
                    <input name="submitSearch" type="submit" class="formButton" value="<?php echo t("Αναζήτηση"); ?>">
                </div>
            </div>
        </form>
        <?php
        return ob_get_clean();
    }


} // end class
?>