<?php
require_once("dll.php");
$db->query("SET NAMES 'utf8mb4'");
$document = new document("products", "node");
$variables->getSafeVars(array_keys($_REQUEST));
$id = (int)$id;
if (!$id) die("Product ID not defined");

$data = view("products/getData", $document->item);
$include_vat = $parameters->getParameter("include_vat");
if (!$data) $messages->addError("Product not found");

$template = $document->getDefaultTemplate();


?>
<!DOCTYPE html>
<html>
<head>

    <?php
    $document->getMeta();
    $document->getStyles();
    $document->getJsFiles();
    $document->getJsReady();
    $template_quick_view_css = "templates/" . $template . "/css/quick_view.css";
    $quick_view_css = (is_file($template_quick_view_css)) ? $template_quick_view_css : "css/quick_view.css";
    ?>
    <link href="<?php echo $quick_view_css; ?>" rel="stylesheet" type="text/css">
    <?php

    /* CONTROLLER JAVASCRIPT ******************************/
    echo $document->javascript;
    /* CONTROLLER JAVASCRIPT ******************************/

    echo view("utilities/rainbow");
    ?>
</head>
<body id="quick_view_body" style="height:700px;">
<?php
$p = $document->getTemplatePath(); // use the $p shortcut to refer to the template path
$settings_file = $p . "config.php";
if (is_file($settings_file)) include($settings_file); // settings configuration
?>
<div id="ajax_loading"></div>
<div id="qv_top_heading">
    <span class="qv_top_header"><?php echo t("Προβολή προϊόντος", $langID, "top_heading"); ?></span>
    <a href="javascript:parent.$.fancybox.close()" id="close_quick_view"></a>
</div>
<?php
echo view("products/getSetLayout");
?>
<div id="qv_content" itemscope itemtype="https://schema.org/Product" data-productID="<?php echo $data->id;?>" data-inventory_type="<?php echo $data->inventory_type;?>" data-instock="<?php echo $data->instock;?>">
    <?php
    $messages->printSystemMessages();
    if (count($data->images)) {
        $defaultImage = $data->images[0];
        $imgDescription = $content->getImageDescription($defaultImage, $data->id, $document->sectionID, $langID);
        ?>
        <div id="qv_images">
            <?php
            if (!empty($data->save_percent)) {
                ?>
                <div class="qv_save_price">
                    <?php echo t("Κερδίζετε", $langID, "save_image") . " "; ?>
                    <span class="qv_save_price_percent"><?php echo $data->save_percent; ?></span>%
                </div>
                <?php
            }
            ?>
            <div id="qv_image_wrapper">
                <a rel="fb" id="qv_current_image_link" data-rel="qv_image" href="mediabank/images/<?php echo $defaultImage; ?>" title="<?php echo htmlspecialchars($imgDescription); ?>">
                    <img alt="<?php echo htmlspecialchars($imgDescription);?>" itemprop="image" id="qv_current_image" class="qv_image zoomable" src="mediabank/medium/medium_<?php echo $defaultImage; ?>" data-image="<?php echo $defaultImage; ?>">
                </a>
            </div>
            <?php
            if (count($data->images) > 1) {
                foreach ($data->images as $image) {
                    $imgDescription = $content->getImageDescription($image, $data->id, $document->sectionID, $langID);
                    $class = ($image == $defaultImage) ? " qv_thumb_active" : NULL;
                    ?>
                    <a data-image="<?php echo $image; ?>" data-caption="<?php echo htmlspecialchars($imgDescription); ?>" class="qv_thumb<?php echo $class; ?>">
                        <div class="qv_thumb_wrapper"><img src="<?php echo "mediabank/thumbs/small_" . $image; ?>"></div>
                    </a>
                    <?php
                }
            }
            ?>
            <div style="clear:both; height:20px;"></div>
        </div>
        <?php
    }
    ?>


    <div id="qv_details">
        <a class="qv_title"><span itemprop="name"><?php echo $data->title; ?></span></a>
        <div><?php $eshop->displayRating($data->id); ?></div>
        <?php
        if (!empty($data->brandID)) {
            echo t("Δείτε όλα τα προϊόντα από") . " ";
            ?>
            <a target="_top" href="<?php echo $sef->url("index.php?section=products&view=list&brandID=" . $data->brandID . "&langID=" . $langID); ?>">
                <span itemprop="brand"><?php echo $content->getValue("manufacturers", $data->brandID, "title", $langID); ?></span>
            </a>
            <?php
        }
        ?>
        <div class="qv_description"><span itemprop="description"><?php echo $data->description; ?></span></div>
        <?php
        if ((int)$data->inventory_type < 3){
        ?>
        <div class="qv_blocks">
            <div class="qv_block">
                <span class="qv_label"><?php echo t("Διαθεσιμότητα"); ?>: </span>
                <span id="inventory" class="qv_value<?php echo $data->availability_class; ?>"><?php echo $data->availability; ?></span>
            </div>
            <?php
            }
            if ($data->code) {
                ?>
                <div class="qv_block">
                    <span class="qv_label"><?php echo t("Κωδικός"); ?>: </span>
                    <span class="qv_value" id="qv_code" data-code="<?php echo $data->code; ?>" itemprop="mpn"><?php echo $data->code; ?></span>
                </div>
                <?php
            }
            if ($data->hasPriceAccess) {
                if (!empty($data->list_price)) {
                    ?>
                    <div class="qv_block">
                        <span class="qv_label"><?php echo t("Λιανική τιμή"); ?>: </span>
                        <span id="list_price" class="qv_list_price" data-list_price="<?php echo $data->list_price; ?>"><?php echo $data->formated_list_price; ?></span>
                    </div>
                    <?php
                }
                if (!empty($data->price)) {
                    ?>
                    <div id="qv_price" data-price="<?php echo $data->price; ?>" data-basePrice="<?php echo $data->price; ?>"><?php echo $data->formated_price; ?></div>
                    <?php
                    if (empty($include_vat)) {
                        $final_price = $eshop->includeVat($data->price, $data->vat);
                        ?>
                        <div id="qv_final_price"><?php echo "(" . $eshop->formatPrice($final_price) . " " . t("με ΦΠΑ") . ")"; ?></div>
                        <?php
                    }
                }
                if (!empty($data->list_price)) {
                    $save_price = $data->list_price - $data->price;
                    $save_text = (!$include_vat) ?
                        t("Κερδίζετε", $langID, "save_text") . ": <span id='save_price' data-save_price='" . (float)$save_price . "'>" . $eshop->formatPrice($save_price) . "</span> (<span id='save_percent'>" . $data->save_percent . "</span>%)" :
                        t("Κερδίζετε", $langID, "save_text") . ": <span id='save_percent'>" . $data->save_percent . "</span>%";
                    ?>
                    <div class="qv_block">
                        <span class="qv_value"><?php echo $save_text; ?></span>
                    </div>
                    <?php
                }
            }

            $eshop->productOptions($data->id); // adds options management
            echo view("products/getBasketControls", $document->item);     // --- DO NOT REMOVE ---  adds required markup, basket and wishlist controls

            if ($data->promo_text) {
                ?>
                <div class="qv_block" style="margin: 20px 0;">
                    <div class="qv_promo_text"><?php echo $data->promo_text; ?></div>
                </div>
                <?php
            }
            ?>
        </div> <!-- qv_blocks -->
    </div> <!-- qv_details -->
</div>

<!-- Theme styles and settings -->

<link rel="stylesheet" href="<?php echo $p; ?>css/themes/basic.css"/>
<?php
if ($om) {
    ?>
    <link rel="stylesheet" href="<?php echo $p; ?>css/themes/basic_colors.css"/>
    <link rel="stylesheet" href="<?php echo $p . "css/themes/" . $themeName . ".css"; ?>"/>
    <?php
}
?>

</body>
</html>


