<?php
/*
Odyssey view file
Filename must be like "view_sectionName.php"
Reference to controller variables must be in form $this->varName

Use $p for template path, for example $p/images/logo.png
*/


// *****************************************************************************

$autoView = false; // Warning! You need to set this to false in order to use your custom view below

// *****************************************************************************

if ($autoView){ // you may change this above, setting it as false in order to use your default view starting below

    include("view.php");

}else{ // you custom layout starts here!!!

global $langID;
global $parameters;
global $catID;
$section = $this->section;
$sectionID = $this->sectionID;
if ($catID) {
    $title = $categories->getCategoryName($catID, "content_" . $section . "_categories", $langID);
} else {
    $sectionName = t($system->getTableSectionTitle($sectionID));
    $title = (is_numeric($catID) && $catID == 0) ? $sectionName . " - " . t("ΚΑΤΗΓΟΡΙΕΣ") : $sectionName;
}


?>
<div class="inner_content">
    <div id="breadcrumb"><?php $eshop->displayBreadcrumb(); ?></div>
    <h2>
        <?php echo view("articles/getListingTitle"); ?>
    </h2>
    <?php
    $messages->printSystemMessages();
    if ($this->numOfAllItems || $this->hasSubcategories) {
        if (!$this->hasSubcategories) { // no pagination for categories listing
            echo view("utilities/getPagination", true);
            echo "<div style='height:20px'></div>";
        }
        $items = $this->items;
        foreach ($items as $item) {
            $data = (!$this->hasSubcategories) ? view("articles/getData", $item) : view("articles/getCategoryData", $item);
            if ($data) {
                ?>
                <div class="listing">
                    <?php
                    $content->displayThumbnail($data->mediumImage, 240, $thumbViewportHeight = 150, $data->link, true);
                    ?>
                    <div class="article_listing_container">
                        <h3><a href="<?php echo $data->link; ?>"><?php echo $data->title; ?></a></h3>
                        <div class="minitext"><?php echo $data->minitext; ?></div>
                        <div class="more"><a href="<?php echo $data->link; ?>"><?php echo t('περισσότερα'); ?></a></div>
                        <?php ?>
                    </div>
                </div>
                <div class="clearfix"></div>
                <?php
            }
        }
        ?>
        <div style='height:40px'></div>
        <?php
        echo view("utilities/getPagination", false);
    }
    }
    ?>
</div>
