<?php
/*
Odyssey view file
Filename must be like "view_sectionName.php"
Reference to controller variables must be in form $this->varName

Use $p for template path, for example $p/images/logo.png
*/


// *****************************************************************************

$autoView = false; // Warning! You need to set this to false in order to use your custom view below

// *****************************************************************************

if ($autoView) { // you may change this above, setting it as false in order to use your default view starting below

    include("view.php");

} else { // you custom layout starts here!!!

    global $langID;
    $data = view("products/getData", $this->item);
    $include_vat = $parameters->getParameter("include_vat");
    if (!$data) $messages->addError("Product not found");
    ?>
    <div class="inner_content">

        <div id="breadcrumb"><?php $eshop->displayBreadcrumb(); ?></div>
        <?php
        $messages->printSystemMessages();
        if (!$messages->hasErrors){
        echo view("products/getSetLayout");
        ?>
        <link href="css/quick_view.css" rel="stylesheet" type="text/css">
        <?php


        /* CONTROLLER JAVASCRIPT ******************************/
        echo $this->javascript;
        /* CONTROLLER JAVASCRIPT ******************************/


        echo view("utilities/rainbow");
        ?>

        <div id="qv_content" class="product_node" itemscope itemtype="https://schema.org/Product">
            <?php
            if (count($data->images)) {
                $defaultImage = $data->images[0];
                $imgDescription = $content->getImageDescription($defaultImage, $data->id, $this->sectionID, $langID);
                ?>
                <div id="qv_images">
                    <?php
                    if (!empty($data->save_percent)) {
                        ?>
                        <div class="qv_save_price">
                            <?php echo t("Κερδίζετε", $langID, "save_image") . " "; ?>
                            <span class="qv_save_price_percent"><?php echo $data->save_percent; ?></span>%
                        </div>
                        <?php
                    }
                    ?>
                    <div id="qv_image_wrapper">
                        <a rel="fb" id="qv_current_image_link" data-rel="qv_image" href="mediabank/images/<?php echo $defaultImage; ?>" title="<?php echo htmlspecialchars($imgDescription); ?>">
                            <img alt="<?php echo htmlspecialchars($imgDescription); ?>" itemprop="image" id="qv_current_image" class="qv_image zoomable" src="mediabank/medium/medium_<?php echo $defaultImage; ?>" data-image="<?php echo $defaultImage; ?>">
                        </a>
                    </div>
                    <?php
                    if (count($data->images) > 1) {
                        foreach ($data->images as $image) {
                            $imgDescription = $content->getImageDescription($image, $data->id, $this->sectionID, $langID);
                            $class = ($image == $defaultImage) ? " qv_thumb_active" : NULL;
                            ?>
                            <a data-image="<?php echo $image; ?>" data-caption="<?php echo htmlspecialchars($imgDescription); ?>" class="qv_thumb<?php echo $class; ?>">
                                <div class="qv_thumb_wrapper"><img src="<?php echo "mediabank/thumbs/small_" . $image; ?>"></div>
                            </a>
                            <?php
                        }
                    }
                    ?>
                    <div style="clear:both;"></div>
                </div>
                <?php
            }
            ?>
            <div id="qv_details" class="product_details">
                <a class="qv_title"><span itemprop="name"><?php echo $data->title; ?></span></a>
                <div><?php $eshop->displayRating($data->id); ?></div>
                <?php
                if (!empty($data->brandID)) {
                    echo t("Δείτε όλα τα προϊόντα από") . " ";
                    ?>
                    <a href="<?php echo $sef->url("index.php?section=products&view=list&brandID=" . $data->brandID . "&langID=" . $langID); ?>">
                        <span itemprop="brand"><?php echo $content->getValue("manufacturers", $data->brandID, "title", $langID); ?></span>
                    </a>
                    <?php
                }
                if ((int)$data->inventory_type < 3){
                ?>
                <div class="qv_blocks">
                    <div class="qv_block">
                        <span class="qv_label"><?php echo t("Διαθεσιμότητα"); ?>: </span>
                        <span id="inventory" class="qv_value<?php echo $data->availability_class; ?>"><?php echo $data->availability; ?></span>
                    </div>
                    <?php
                    }
                    if ($data->code) {
                        ?>
                        <div class="qv_block">
                            <span class="qv_label"><?php echo t("Κωδικός"); ?>: </span>
                            <span class="qv_value" id="qv_code" data-code="<?php echo $data->code; ?>" itemprop="mpn"><?php echo $data->code; ?></span>
                        </div>
                        <?php
                    }
                    if ($data->hasPriceAccess) {
                        if (!empty($data->list_price)) {
                            ?>
                            <div class="qv_block">
                                <span class="qv_label"><?php echo t("Λιανική τιμή"); ?>: </span>
                                <span id="list_price" class="qv_list_price" data-list_price="<?php echo $data->list_price; ?>"><?php echo $data->formated_list_price; ?></span>
                            </div>
                            <?php
                        }
                        if (!empty($data->price)) {
                            ?>
                            <div id="qv_price" data-price="<?php echo $data->price; ?>" data-basePrice="<?php echo $data->price; ?>"><?php echo $data->formated_price; ?></div>
                            <?php
                            if (empty($include_vat)) {
                                $final_price = $eshop->includeVat($data->price, $data->vat);
                                ?>
                                <div id="qv_final_price"><?php echo "(" . $eshop->formatPrice($final_price) . " " . t("με ΦΠΑ") . ")"; ?></div>
                                <?php
                            }
                        }
                        if (!empty($data->list_price)) {
                            $save_price = $data->list_price - $data->price;
                            $save_text = (!$include_vat) ?
                                t("Κερδίζετε", $langID, "save_text") . ": <span id='save_price' data-save_price='" . (float)$save_price . "'>" . $eshop->formatPrice($save_price) . "</span> (<span id='save_percent'>" . $data->save_percent . "</span>%)" :
                                t("Κερδίζετε", $langID, "save_text") . ": <span id='save_percent'>" . $data->save_percent . "</span>%";
                            ?>
                            <div class="qv_block">
                                <span class="qv_value"><?php echo $save_text; ?></span>
                            </div>
                            <?php
                        }
                    }
                    $eshop->productOptions($data->id); // adds options management
                    echo view("products/getBasketControls", $this->item);     // --- DO NOT REMOVE ---  adds required markup, basket and wishlist controls

                    if ($data->promo_text) {
                        ?>
                        <div class="qv_block" style="margin: 20px 0;">
                            <div class="qv_promo_text"><?php echo $data->promo_text; ?></div>
                        </div>
                        <?php
                    }
                    ?>
                </div> <!-- qv_blocks -->
                <div style="clear:both;"></div>
            </div> <!-- qv_details -->
            <?php
            echo view("products/getTabs");
            }
            ?>
        </div>
        <div class="related_products">
            <?php
            $document->includeModules("related_products");
            ?>
        </div>
    </div>
    <?php
}// end if !$autoView
?>